﻿using FreeSql.DataAnnotations;
using IMES_Middleware_Platform.Api.Domain.FuelDispenser.Dto;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Linq;
using ZhonTai.Admin.Core.Entities;

namespace IMES_Middleware_Platform.Api.Domain.FuelDispenser
{
    /// <summary>
    /// 报警历史
    /// </summary>
    [Table(Name = "AlarmHistory")]
    public class AlarmHistoryEntity : EntityAdd
    {
        /// <summary>
        /// 油机ID
        /// </summary>
        public int FuelId { get; set; }
        
        public DateTime? CreatedDate { get; set; }
        /// <summary>
        /// 加油站名称
        /// </summary>
        public string GasStation { get; set; }
        /// <summary>
        /// 油机号
        /// </summary>
        public string Name { get; set; }
        /// <summary>
        /// 序列号
        /// </summary>
        public string SerialNumber { get; set; }
        /// <summary>
        /// 报警来源
        /// </summary>
        public string AlarmSource { get; set; }
        /// <summary>
        /// 报警类型
        /// </summary>
        public string AlarmType { get; set; }
        /// <summary>
        /// 报警描述
        /// </summary>
        public string AlarmDescription { get; set; }
        public int AlarmHistoryID { get; set; }
        /// <summary>
        /// 报警设备id
        /// </summary>
        public int AlarmDeviceId { get; set; }
        /// <summary>
        /// 报警设备 
        /// 告警域[dispenser
        ///blackBox
        ///valveControl
        ///taxControl
        ///displayControl
        ///encoderControl
        ///nozzleControl 
        ///meter]
        /// </summary>
        public string  AlarmDevice { get; set; }
        /// <summary>
        /// 详细描述
        /// </summary>
        public string Description { get; set; }
        /// <summary>
        /// 油站ID
        /// </summary>
        public int? StationID { get; set; }
        /// <summary>
        /// 油站公司
        /// </summary>
        public int? CompanyID { get; set; }
        /// <summary>
        /// 供应商名称
        /// </summary>
        public string  SupplierName { get; set; }
        /// <summary>
        /// 供应商ID
        /// </summary>
        public int? SupplierID { get; set; }
        /// <summary>
        /// 石油公司
        /// </summary>
        public string CompanyName { get; set; }
        /// <summary>
        /// 报警等级
        /// </summary>
        public int? AlarmLevel { get; set; }
        /// <summary>
        ///IOT告警序列号
        /// </summary>
        public long GenSeq { get; set; }
        /// <summary>
        /// 安全装置ID
        /// </summary>
        public int BlackBoxId { get; set; }
        /// <summary>
        /// 油枪ID
        /// </summary>
        public int NozzleControlID { get; set; }
    }
}
