﻿using FreeSql.DataAnnotations;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ZhonTai.Admin.Core.Entities;

namespace IMES_Middleware_Platform.Api.Domain.FuelDispenser
{
    /// <summary>
    /// 协会账户
    /// </summary>
    [Table(Name = "AssociationUser")]
    public class AssociationUserEntity : EntityAdd
    {
        /// <summary>
        /// 是否具有管理员权限。
        /// </summary>
        public bool Admin { get; set; }

        /// <summary>
        /// 账户是否锁定。
        /// </summary>
        public string IsLock { get; set; }

        /// <summary>
        /// 密码更新时间。
        /// </summary>
        public DateTime? UpdatePasswordTime { get; set; }

        /// <summary>
        /// 需要修改密码。
        /// </summary>
        public bool ModifyPass { get; set; }

        /// <summary>
        ///  ID。
        /// </summary>
        public int ModifiedBy { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public int Id { get; set; }

        /// <summary>
        /// 电子邮件地址。
        /// </summary>
        public string Email { get; set; }

        /// <summary>
        /// 姓名。
        /// </summary>
        public string IdentityName { get; set; }

        /// <summary>
        /// 手机号码。
        /// </summary>
        public string Mobile { get; set; }

        /// <summary>
        /// 创建日期。
        /// </summary>
        public long CreatedDate { get; set; }

        /// <summary>
        ///用户 ID。
        /// </summary>
        public int CreatedBy { get; set; }

        /// <summary>
        /// 身份证号码。
        /// </summary>
        public string IdentityId { get; set; }

        /// <summary>
        /// 是否禁用。
        /// </summary>
        public bool Disable { get; set; }

        /// <summary>
        /// 用户名。
        /// </summary>
        public string Name { get; set; }

        /// <summary>
        /// 修改日期。
        /// </summary>
        public long ModifiedDate { get; set; }

        /// <summary>
        /// 年龄。
        /// </summary>
        public int Age { get; set; }
    }
}
