﻿using FreeSql.DataAnnotations;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ZhonTai.Admin.Core.Entities;

namespace IMES_Middleware_Platform.Api.Domain.FuelDispenser
{
    /// <summary>
    /// 安全装置
    /// </summary>
    [Table(Name = "BlackBox")]
    public class BlackBoxEntity : EntityAdd
    {
        /// <summary>
        /// 报警状态。
        /// </summary>
        public bool Alarming { get; set; }

        /// <summary>
        /// 重置次数。
        /// </summary>
        public int ResetTimes { get; set; }

        /// <summary>
        /// 在线状态日期。
        /// </summary>
        public DateTime? OnlineStatusDate { get; set; }

        /// <summary>
        /// 设备报警级别。
        /// </summary>
        public int DeviceAlarmLevel { get; set; }

        /// <summary>
        /// 在线状态。
        /// </summary>
        public string OnlineStatus { get; set; }

        /// <summary>
        /// 出厂时间。
        /// </summary>
        public DateTime? ProductTime { get; set; }

        /// <summary>
        ///  UUID。
        /// </summary>
        public string Uuid { get; set; }

        /// <summary>
        /// 签名验证状态。
        /// </summary>
        public bool SignVerify { get; set; }

        /// <summary>
        /// 设备状态。
        /// </summary>
        public string DeviceStatus { get; set; }

        /// <summary>
        /// 加油机ID
        /// </summary>
        public int FuelID { get; set; }

        /// <summary>
        /// 二维码。
        /// </summary>
        public string QrCode { get; set; }

        /// <summary>
        /// 用户 ID。
        /// </summary>
        public int ModifiedBy { get; set; }

        /// <summary>
        /// 报警级别。
        /// </summary>
        public int AlarmLevel { get; set; }

        /// <summary>
        ///
        /// </summary>
        public int Id { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public bool Filtering { get; set; }

        /// <summary>
        ///加油机供应商 ID。
        /// </summary>
        public int DispenserSupplierId { get; set; }

        /// <summary>
        /// 税控类型。
        /// </summary>
        public string TaxType { get; set; }

        /// <summary>
        /// 油枪名称
        /// </summary>
        public string NozzleControlName { get; set; }


        /// <summary>
        /// 安装时间。
        /// </summary>
        public DateTime? FixTime { get; set; }

        /// <summary>
        /// 出厂时间。
        /// </summary>
        public DateTime? SoldTime { get; set; }

        /// <summary>
        /// 报警详情。
        /// </summary>
        public string AlarmDetail { get; set; }


        /// <summary>
        /// 创建日期。
        /// </summary>
        public DateTime? CreatedDate { get; set; }

        /// <summary>
        /// 创建者用户 ID。
        /// </summary>
        public int CreatedBy { get; set; }


        /// <summary>
        /// 修改日期。
        /// </summary>
        public long ModifiedDate { get; set; }

        /// <summary>
        /// 离线报警级别。
        /// </summary>
        public int OfflineAlarmLevel { get; set; }
        /// <summary>
        /// 软件版本号
        /// </summary>
        public string Swv { get; set; }
        /// <summary>
        /// 硬件版本号
        /// </summary>
        public string hdv { get; set; }
        /// <summary>
        /// 告警开始时间。
        /// </summary>
        public DateTime? AlarmTime { get; set; }
        /// <summary>
        /// sim卡imsi
        /// </summary>
        public string Imsi { get; set; }
        /// <summary>
        /// sim卡iccid
        /// </summary>
        public string Iccid { get; set; }
        /// <summary>
        /// 微处理器编号
        /// </summary>
        public string CpuUuid { get; set; }

        /// <summary>
        /// 注册消息更新时间 
        /// </summary>
        public DateTime? RegisterUpdateTime { get; set; }

        /// <summary>
        /// 快照
        /// </summary>
        public string SnapshotJson { get; set; }

        /// <summary>
        /// 扩展属性 
        /// </summary>
        public string Xattrs { get; set; }
        /// <summary>
        /// 机型配置
        /// </summary>
        public string IotType { get; set; }
        /// <summary>
        /// 站点id
        /// </summary>
        public int? StationID { get; set; }
        /// <summary>
        /// 供应商id
        /// </summary>
        public int? supplierID { get; set; }
        /// <summary>
        /// 出厂加油机厂商ID
        /// </summary>
        public int? FactorySupplierID { get; set; }

        /// <summary>
        /// 启用时间
        /// </summary>
        public DateTime? StartTime { get; set; }
        /// <summary>
        /// 照片id
        /// </summary>
        public long PhotoId { get; set; }
        /// <summary>
        /// 错误列表
        /// </summary>
        public string Alarms { get; set; }
        /// <summary>
        /// 法制软件版本
        /// </summary>
        public string LawSwv { get; set; }
        /// <summary>
        /// 法制软件标识
        /// </summary>
        public string LawSwi { get; set; }
    }
}
