﻿using FreeSql.DataAnnotations;
using IMES_Middleware_Platform.Api.Domain.FuelDispenser.Dto;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ZhonTai.Admin.Core.Entities;

namespace IMES_Middleware_Platform.Api.Domain.FuelDispenser
{
    /// <summary>
    /// 计控主板
    /// </summary>
    [Table(Name = "CalculatorMainboard")]
    public class CalculatorMainboardEntity : EntityAdd
    {
        /// <summary>
        /// 唯一ID
        /// </summary>
        public string Uuid { get; set; }
        /// <summary>
        /// 软件版本号
        /// </summary>
        public string Swv { get; set; }
        /// <summary>
        /// 硬件版本号
        /// </summary>
        public string Hdv { get; set; }
        /// <summary>
        /// 计量签名
        /// </summary>
        public string Signature { get; set; }
        /// <summary>
        /// 签名是否正确
        /// </summary>
        public bool SignVerify { get; set; }
        /// <summary>
        /// 是否未上报的疑似脏数据
        /// </summary>
        public bool Dirty { get; set; }
        /// <summary>
        /// 机型配置
        /// </summary>
        public string IotType { get; set; }
        /// <summary>
        /// 计控主板备案程序包
        /// </summary>
        public string CalculatorSoftware { get; set; }
        /// <summary>
        /// 供应商id
        /// </summary>
        public int SupplierID { get; set; }
        /// <summary>
        ///安全装置ID
        /// </summary>
        public int BlackBoxID { get; set; }
        /// <summary>
        /// 站点
        /// </summary>
        public int StationID { get; set; }
        /// <summary>
        /// 加油机ID
        /// </summary>
        public int FuelID { get; set; }
        /// <summary>
        /// 监控微处理器ID
        /// </summary>
        public int TaxControlID { get; set; }
        /// <summary>
        ///  online/offline 状态 
        /// </summary>
        public string OnlineStatus { get; set; }
        /// <summary>
        /// 设备状态 unregister， register， bind， enable， disable
        /// </summary>
        public string DeviceStatus { get; set; }
        /// <summary>
        /// 设备端告警等级
        /// </summary>
        public int DeviceAlarmLevel { get; set; }
        /// <summary>
        /// 生产时间
        /// </summary>
        public DateTime? ProductTime { get; set; }
        /// <summary>
        /// 出厂时间
        /// </summary>
        public DateTime? SoldTime { get; set; }
        /// <summary>
        /// 启用时间
        /// </summary>
        public DateTime? StartTime { get; set; }

        /// <summary>
        /// 照片id
        /// </summary>
        public long PhotoId { get; set; }
        /// <summary>
        /// 安装时间
        /// </summary>
        public DateTime? FixTime { get; set; }
        /// <summary>
        /// 错误列表
        /// </summary>
        public string Alarms { get; set; }
        /// <summary>
        /// 法制软件版本
        /// </summary>
        public string LawSwv { get; set; }
        /// <summary>
        /// 法制软件标识
        /// </summary>
        public string LawSwi { get; set; } 
    }
}
