﻿using FreeSql.DataAnnotations;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ZhonTai.Admin.Core.Entities;

namespace IMES_Middleware_Platform.Api.Domain.FuelDispenser
{
    /// <summary>
    /// 站点公司
    /// </summary>
    [Table(Name = "Company")]
    public class CompanyEntity : EntityAdd
    {
        /// <summary>
        ///公司类型。
        /// </summary>
        public string GroupType { get; set; }

        /// <summary>
        /// 公司代码。
        /// </summary>
        public string Code { get; set; }


        /// <summary>
        /// 描述。
        /// </summary>
        public string Description { get; set; }


        /// <summary>
        /// 注册号。
        /// </summary>
        public string RegisterNo { get; set; }

        /// <summary>
        /// 创建日期。
        /// </summary>
        public long CreatedDate { get; set; }

        /// <summary>
        /// 用户 ID。
        /// </summary>
        public int CreatedBy { get; set; }

        /// <summary>
        /// 电话。
        /// </summary>
        public string Phone { get; set; }

        /// <summary>
        /// 联系人。
        /// </summary>
        public string Contact { get; set; }

        /// <summary>
        /// 公司名称。
        /// </summary>
        public string Name { get; set; }

        /// <summary>
        /// 修改日期。
        /// </summary>
        public long ModifiedDate { get; set; }

        /// <summary>
        /// 用户 ID。
        /// </summary>
        public int ModifiedBy { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public int Id { get; set; }
    }
}
