﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IMES_Middleware_Platform.Api.Domain.FuelDispenser.Dto
{
    public class AlarmRootobject
    {
        public Data data { get; set; }
        public string message { get; set; }
        public string requestId { get; set; }
        public int status { get; set; }
    }

    public class Data
    {
        public int number { get; set; }
        public int numberOfElements { get; set; }
        public int size { get; set; }
        public int totalPages { get; set; }
        public Pageable pageable { get; set; }
        public Sort1 sort { get; set; }
        public AlarmHistoryContent[] content { get; set; }
        public int totalElements { get; set; }
    }

    //public class Pageable
    //{
    //    public int pageNumber { get; set; }
    //    public int offset { get; set; }
    //    public int pageSize { get; set; }
    //    public Sort sort { get; set; }
    //}

    //public class Sort
    //{
    //}


    public class AlarmHistoryContent
    {
        public string origin { get; set; }
        public long? alarmTime { get; set; }
        public string nozzleControlName { get; set; }
        public string description { get; set; }
        public string alarmDevice { get; set; }
        public int genSeq { get; set; }
        public int alarmDeviceId { get; set; }
        public Dispenser dispenser { get; set; }
        public long? createdDate { get; set; }
        public int createdBy { get; set; }
        public Alarm alarm { get; set; }
        public long? modifiedDate { get; set; }
        public int modifiedBy { get; set; }
        public int id { get; set; }
        public Station station { get; set; }
        public Company company { get; set; }
    }

    public class Dispenser
    {
        public string measureRang { get; set; }
        public bool alarming { get; set; }
        public int deviceAlarmLevel { get; set; }
        public string onlineStatus { get; set; }
        public long? productTime { get; set; }
        public string type { get; set; }
        public string accuracyLevel { get; set; }
        public string uuid { get; set; }
        public string deviceStatus { get; set; }
        public bool _lock { get; set; }
        public int modifiedBy { get; set; }
        public long? startTime { get; set; }
        public int alarmLevel { get; set; }
        public int id { get; set; }
        public string modelSpec { get; set; }
        public string serialNum { get; set; }
        public bool test { get; set; }
        public object[] sealNo { get; set; }
        public object[] alarms { get; set; }
        public long? alarmTime { get; set; }
        public int photoId { get; set; }
        public long? fixTime { get; set; }
        public object[] photoIds { get; set; }
        public long? soldTime { get; set; }
        public string[] alarmDetail { get; set; }
        public long? createdDate { get; set; }
        public int createdBy { get; set; }
        public bool repairing { get; set; }
        public string name { get; set; }
        public long? modifiedDate { get; set; }
        public string setup { get; set; }
        public int noticesTotal { get; set; }
        public int nozzleControlsTotal { get; set; }
        public string[] changeInfo { get; set; }
        public Supplier supplier { get; set; }
        public string canLock { get; set; }
    }

    //public class Supplier
    //{
    //    public string groupType { get; set; }
    //    public string code { get; set; }
    //    public int standardId { get; set; }
    //    public string description { get; set; }
    //    public int photoId { get; set; }
    //    public string registerNo { get; set; }
    //    public long? createdDate { get; set; }
    //    public string[] deviceTypes { get; set; }
    //    public int createdBy { get; set; }
    //    public string name { get; set; }
    //    public long? modifiedDate { get; set; }
    //    public string alias { get; set; }
    //    public int modifiedBy { get; set; }
    //    public int id { get; set; }
    //}

    //public class Alarm
    //{
    //    public int code { get; set; }
    //    public string typeDisplay { get; set; }
    //    public int level { get; set; }
    //    public string description { get; set; }
    //    public int id { get; set; }
    //    public string type { get; set; }
    //    public string device { get; set; }
    //}

    //public class Station
    //{
    //    public bool alarming { get; set; }
    //    public string districtCode { get; set; }
    //    public string city { get; set; }
    //    public string cityCode { get; set; }
    //    public string type { get; set; }
    //    public string registerNo { get; set; }
    //    public string province { get; set; }
    //    public string contact { get; set; }
    //    public int modifiedBy { get; set; }
    //    public int id { get; set; }
    //    public float lat { get; set; }
    //    public string address { get; set; }
    //    public float lng { get; set; }
    //    public bool test { get; set; }
    //    public bool business { get; set; }
    //    public string provinceCode { get; set; }
    //    public long? alarmTime { get; set; }
    //    public int photoId { get; set; }
    //    public object[] tags { get; set; }
    //    public int dispensersTotal { get; set; }
    //    public long? createdDate { get; set; }
    //    public string phone { get; set; }
    //    public int createdBy { get; set; }
    //    public string district { get; set; }
    //    public string name { get; set; }
    //    public long? modifiedDate { get; set; }
    //    public int noticesTotal { get; set; }
    //    public int nozzleControlsTotal { get; set; }
    //}

    //public class Company
    //{
    //    public string groupType { get; set; }
    //    public string code { get; set; }
    //    public int standardId { get; set; }
    //    public string description { get; set; }
    //    public int photoId { get; set; }
    //    public string registerNo { get; set; }
    //    public long? createdDate { get; set; }
    //    public object[] deviceTypes { get; set; }
    //    public int createdBy { get; set; }
    //    public string phone { get; set; }
    //    public string contact { get; set; }
    //    public string name { get; set; }
    //    public long? modifiedDate { get; set; }
    //    public int modifiedBy { get; set; }
    //    public int id { get; set; }
    //}

}
