﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IMES_Middleware_Platform.Api.Domain.FuelDispenser.Dto
{

    public class DispenserDto
    {
        public DispenserData data { get; set; }
        public string message { get; set; }
        public string requestId { get; set; }
        public int status { get; set; }
    }

    public class DispenserData
    {
        public int number { get; set; }
        public int size { get; set; }
        public int numberOfElements { get; set; }
        public int totalPages { get; set; }
        public Pageable pageable { get; set; }
        public Sort1 sort { get; set; }
        public DispenserContent[] content { get; set; }
        public int totalElements { get; set; }
    }



    public class DispenserContent
    {
        public string measureRang { get; set; }
        public bool alarming { get; set; }
        public int deviceAlarmLevel { get; set; }
        public string onlineStatus { get; set; }
        public long productTime { get; set; }
        public string type { get; set; }
        public string accuracyLevel { get; set; }
        public string uuid { get; set; }
        public string deviceStatus { get; set; }
        public long lockTime { get; set; }
        public string[] changeInfo { get; set; }
        public Supplier supplier { get; set; }
        public Station station { get; set; }
        public DispenserNozzlecontrol[] nozzleControls { get; set; }
        public bool _lock { get; set; }
        public int modifiedBy { get; set; }
        public long startTime { get; set; }
        public string canLock { get; set; }
        public int alarmLevel { get; set; }
        public int id { get; set; }
        public string modelSpec { get; set; }
        public string serialNum { get; set; }
        public bool test { get; set; }
        public string[] sealNo { get; set; }
        public object[] alarms { get; set; }
        public long alarmTime { get; set; }
        public int photoId { get; set; }
        public long fixTime { get; set; }
        public int?[] photoIds { get; set; }
        public long soldTime { get; set; }
        public string[] alarmDetail { get; set; }
        public long createdDate { get; set; }
        public int createdBy { get; set; }
        public bool repairing { get; set; }
        public string name { get; set; }
        public long modifiedDate { get; set; }
        public string setup { get; set; }
        public int noticesTotal { get; set; }
        public int nozzleControlsTotal { get; set; }
        public long lastInspectTime { get; set; }
    }


    public class DispenserNozzlecontrol
    {
        public int mainBoard { get; set; }
        public bool hidden { get; set; }
        public int deviceAlarmLevel { get; set; }
        public string onlineStatus { get; set; }
        public object[] taxAlarms { get; set; }
        public string iotType { get; set; }
        public string deviceStatus { get; set; }
        public int modifiedBy { get; set; }
        public long startTime { get; set; }
        public int alarmLevel { get; set; }
        public Fuel fuel { get; set; }
        public int id { get; set; }
        public string value { get; set; }
        public bool dirty { get; set; }
        public string recover { get; set; }
        public long ecqsDate { get; set; }
        public object[] alarms { get; set; }
        public int photoId { get; set; }
        public long fixTime { get; set; }
        public string[] alarmDetail { get; set; }
        public long createdDate { get; set; }
        public int nozzleNo { get; set; }
        public int createdBy { get; set; }
        public string name { get; set; }
        public long modifiedDate { get; set; }
        public string cheatStatus { get; set; }
        public long productTime { get; set; }
        public long soldTime { get; set; }
    }
}
