﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IMES_Middleware_Platform.Api.Domain.FuelDispenser.Dto
{
    public class FuelDispenserDto
    {
        /// <summary>
        /// 加油机名称
        /// </summary>
        public string Name { get; set; }
        public int FuelId { get; set; }

        /// <summary>
        /// 石油公司
        /// </summary>
        public string OilCompany { get; set; }

        /// <summary>
        /// 加油站
        /// </summary>
        public string GasStation { get; set; }

        /// <summary>
        /// 序列号
        /// </summary>
        public string SerialNumber { get; set; }

        /// <summary>
        /// 加油机机型
        /// </summary>
        public string Model { get; set; }

        /// <summary>
        /// 加油机枪数量
        /// </summary>
        public int GunCount { get; set; }

        /// <summary>
        /// 加油机厂商
        /// </summary>
        public string Manufacturer { get; set; }

        /// <summary>
        /// 出厂时间
        /// </summary>
        public DateTime? ManufactureDate { get; set; }

        /// <summary>
        /// 启动时间
        /// </summary>
        public DateTime? StartupDate { get; set; }

        /// <summary>
        /// 安装时间
        /// </summary>
        public DateTime? InstallationDate { get; set; }

        /// <summary>
        /// 设备状态
        /// </summary>
        public string DeviceStatus { get; set; }

        /// <summary>
        /// 在线状态
        /// </summary>
        public string OnlineStatus { get; set; }
        /// <summary>
        /// 测量范围
        /// </summary>
        public string MeasureRang { get; set; }
        /// <summary>
        /// 准确度等级
        /// </summary>
        public string AccuracyLevel { get; set; }
        /// <summary>
        /// 规格参数
        /// </summary>
        public string ModelSpec { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public string Description { get; set; }
        /// <summary>
        /// 报警状态
        /// </summary>
        public int AlarmLevel { get; set; }
        /// <summary>
        /// 累计在线时间
        /// </summary>
        public string OnlineDesc { get; set; }
        /// <summary>
        /// 省份
        /// </summary>
        public string Province { get; set; }
        /// <summary>
        /// 联系方式
        /// </summary>
        public string Phone { get; set; }
        /// <summary>
        /// 联系人
        /// </summary>
        public string Contact { get; set; }
        /// <summary>
        /// 多个铅封号
        /// </summary>
        public string SealNo { get; set; }
        /// <summary>
        /// 多个附件
        /// </summary>
        public string photoIds { get; set; }
        /// <summary>
        /// 验证码
        /// </summary>
        public string VerificationCode { get; set; }

        public FuelDispenserEntity ToFuelDispenser(FuelDispenserDto gasPump)
        {
            return new FuelDispenserEntity()
            {
                Name = gasPump.Name,
                OilCompany = gasPump.OilCompany,
                GasStation = gasPump.GasStation,
                SerialNumber = gasPump.SerialNumber,
                Model = gasPump.Model,
                GunCount = gasPump.GunCount,
                Manufacturer = gasPump.Manufacturer,
                ManufactureDate = gasPump.ManufactureDate,
                StartupDate = gasPump.StartupDate,
                InstallationDate = gasPump.InstallationDate,
                DeviceStatus = gasPump.DeviceStatus,
                OnlineStatus = gasPump.OnlineStatus,
                MeasureRang = gasPump.MeasureRang,
                AccuracyLevel = gasPump.AccuracyLevel,
                ModelSpec = gasPump.ModelSpec,
                FuelId = gasPump.FuelId,
                Description = gasPump.Description,
                AlarmLevel = gasPump.AlarmLevel,
                OnlineDesc = gasPump.OnlineDesc,
                Province = gasPump.Province,
                Phone = gasPump.Phone,
                Contact = gasPump.Contact,
                SealNo = gasPump.SealNo,
                photoIds = gasPump.photoIds,
                VerificationCode = gasPump.VerificationCode
            };
        }
    }
}
