﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IMES_Middleware_Platform.Api.Domain.FuelDispenser.Dto
{


    public class NozzleDetails
    {
        public NozzleDetailsData data { get; set; }
        public string message { get; set; }
        public string requestId { get; set; }
        public int status { get; set; }
    }

    public class NozzleDetailsData
    {
        public NozzleDetailsTaxcontrol taxControl { get; set; }
        public int mainBoard { get; set; }
        public bool hidden { get; set; }
        public int deviceAlarmLevel { get; set; }
        public string onlineStatus { get; set; }
        public object[] taxAlarms { get; set; }
        public string iotType { get; set; }
        public long productTime { get; set; }
        public NozzleMeter[] meters { get; set; }
        public string deviceStatus { get; set; }
        public NozzleStation station { get; set; }
        public int modifiedBy { get; set; }
        public long startTime { get; set; }
        public NozzleEncodercontrol[] encoderControls { get; set; }
        public int alarmLevel { get; set; }
        public int id { get; set; }
        public string value { get; set; }
        public NozzleDisplaycontrol[] displayControls { get; set; }
        public bool dirty { get; set; }
        public string recover { get; set; }
        public long ecqsDate { get; set; }
        public object[] alarms { get; set; }
        public int photoId { get; set; }
        public long fixTime { get; set; }
        public Vaporrecoverycontrol vaporRecoveryControl { get; set; }
        public long soldTime { get; set; }
        public string[] alarmDetail { get; set; }
        public long createdDate { get; set; }
        public NozzleBlackbox blackBox { get; set; }
        public int nozzleNo { get; set; }
        public int createdBy { get; set; }
        public string name { get; set; }
        public long modifiedDate { get; set; }
        public string cheatStatus { get; set; }
        public object[] valveControls { get; set; }
    }

    public class NozzleDetailsTaxcontrol
    {
        public long onlineStatusDate { get; set; }
        public int deviceAlarmLevel { get; set; }
        public string onlineStatus { get; set; }
        public string uuid { get; set; }
        public bool signVerify { get; set; }
        public int id { get; set; }
        public string mainBoardUuid { get; set; }
        public string nozzleControlName { get; set; }
        public long fixTime { get; set; }
        public int bindMainBoard { get; set; }
        public long soldTime { get; set; }
        public object[] alarmDetail { get; set; }
        public long modifiedDate { get; set; }
        public int offlineAlarmLevel { get; set; }
        public int bindResetTimes { get; set; }
        public int mainBoard { get; set; }
        public int resetTimes { get; set; }
        public string signature { get; set; }
        public string lawSwv { get; set; }
        public long productTime { get; set; }
        public string deviceStatus { get; set; }
        public int modifiedBy { get; set; }
        public string lawSwi { get; set; }
        public long startTime { get; set; }
        public int alarmLevel { get; set; }
        public string sn { get; set; }
        public int dispenserSupplierId { get; set; }
        public long registerDate { get; set; }
        public bool dirty { get; set; }
        public object[] alarms { get; set; }
        public int photoId { get; set; }
        public long createdDate { get; set; }
        public int createdBy { get; set; }
        public string hdv { get; set; }
    }

    public class NozzleStation
    {
        public bool alarming { get; set; }
        public string districtCode { get; set; }
        public string city { get; set; }
        public string cityCode { get; set; }
        public int groupId { get; set; }
        public string type { get; set; }
        public string registerNo { get; set; }
        public string province { get; set; }
        public string contact { get; set; }
        public int modifiedBy { get; set; }
        public int id { get; set; }
        public int state { get; set; }
        public float lat { get; set; }
        public string address { get; set; }
        public float lng { get; set; }
        public bool test { get; set; }
        public bool business { get; set; }
        public string provinceCode { get; set; }
        public long alarmTime { get; set; }
        public int photoId { get; set; }
        public object[] tags { get; set; }
        public int dispensersTotal { get; set; }
        public long createdDate { get; set; }
        public string phone { get; set; }
        public int createdBy { get; set; }
        public string district { get; set; }
        public string name { get; set; }
        public long modifiedDate { get; set; }
        public int noticesTotal { get; set; }
        public int nozzleControlsTotal { get; set; }
    }

    public class Vaporrecoverycontrol
    {
        public int deviceAlarmLevel { get; set; }
        public string signature { get; set; }
        public string onlineStatus { get; set; }
        public long productTime { get; set; }
        public bool signVerify { get; set; }
        public string uuid { get; set; }
        public string deviceStatus { get; set; }
        public int modifiedBy { get; set; }
        public long startTime { get; set; }
        public int alarmLevel { get; set; }
        public int id { get; set; }
        public int dispenserSupplierId { get; set; }
        public bool dirty { get; set; }
        public object[] alarms { get; set; }
        public int photoId { get; set; }
        public long fixTime { get; set; }
        public long soldTime { get; set; }
        public string[] alarmDetail { get; set; }
        public long createdDate { get; set; }
        public int createdBy { get; set; }
        public long modifiedDate { get; set; }
        public int offlineAlarmLevel { get; set; }
    }

    public class NozzleBlackbox
    {
        public bool alarming { get; set; }
        public long onlineStatusDate { get; set; }
        public int deviceAlarmLevel { get; set; }
        public string onlineStatus { get; set; }
        public string iotType { get; set; }
        public bool signVerify { get; set; }
        public string uuid { get; set; }
        public string iccid { get; set; }
        public string swv { get; set; }
        public string qrCode { get; set; }
        public int id { get; set; }
        public bool filtering { get; set; }
        public string taxType { get; set; }
        public string nozzleControlName { get; set; }
        public long fixTime { get; set; }
        public long soldTime { get; set; }
        public object[] alarmDetail { get; set; }
        public string[] snapshot2 { get; set; }
        public long modifiedDate { get; set; }
        public int offlineAlarmLevel { get; set; }
        public string cpuUuid { get; set; }
        public int resetTimes { get; set; }
        public long productTime { get; set; }
        public string imsi { get; set; }
        public string deviceStatus { get; set; }
        public string smUuid { get; set; }
        public int modifiedBy { get; set; }
        public long startTime { get; set; }
        public int alarmLevel { get; set; }
        public int dispenserSupplierId { get; set; }
        public long alarmTime { get; set; }
        public object[] alarms { get; set; }
        public int photoId { get; set; }
        public long createdDate { get; set; }
        public int createdBy { get; set; }
        public NozzleXattrs xattrs { get; set; }
        public string imei { get; set; }
        public string hdv { get; set; }
        public long registerUpdateTime { get; set; }
    }

    public class NozzleXattrs
    {
        public NozzleUart6cancontrols uart6CanControls { get; set; }
        public NozzleUart5cancontrols uart5CanControls { get; set; }
        public string netDevice { get; set; }
        public int strength { get; set; }
        public string buildTime { get; set; }
        public int onchipFlash { get; set; }
        public string sn { get; set; }
        public NozzleSafechipcontrols safeChipControls { get; set; }
    }

    public class NozzleUart6cancontrols
    {
        public int cover { get; set; }
        public int canBaud { get; set; }
        public string swv { get; set; }
        public string buildTime { get; set; }
        public string hdid { get; set; }
        public string hdv { get; set; }
    }

    public class NozzleUart5cancontrols
    {
        public int cover { get; set; }
        public int canBaud { get; set; }
        public string swv { get; set; }
        public string buildTime { get; set; }
        public string hdid { get; set; }
        public string hdv { get; set; }
    }

    public class NozzleSafechipcontrols
    {
        public int cover { get; set; }
        public string swv { get; set; }
        public string buildTime { get; set; }
        public string hdid { get; set; }
        public int supplier_type { get; set; }
        public int secret { get; set; }
        public string hdv { get; set; }
    }

    public class NozzleMeter
    {
        public int deviceAlarmLevel { get; set; }
        public string onlineStatus { get; set; }
        public object[] alarms { get; set; }
        public string nozzleControlName { get; set; }
        public int photoId { get; set; }
        public long fixTime { get; set; }
        public string uuid { get; set; }
        public string deviceStatus { get; set; }
        public object[] alarmDetail { get; set; }
        public long createdDate { get; set; }
        public int createdBy { get; set; }
        public long modifiedDate { get; set; }
        public string setup { get; set; }
        public int modifiedBy { get; set; }
        public int alarmLevel { get; set; }
        public long startTime { get; set; }
        public int id { get; set; }
    }

    public class NozzleEncodercontrol
    {
        public long onlineStatusDate { get; set; }
        public int deviceAlarmLevel { get; set; }
        public string signature { get; set; }
        public string onlineStatus { get; set; }
        public string lawSwv { get; set; }
        public long productTime { get; set; }
        public string uuid { get; set; }
        public bool signVerify { get; set; }
        public string deviceStatus { get; set; }
        public int modifiedBy { get; set; }
        public long startTime { get; set; }
        public int alarmLevel { get; set; }
        public string lawSwi { get; set; }
        public string sn { get; set; }
        public int id { get; set; }
        public int dispenserSupplierId { get; set; }
        public long registerDate { get; set; }
        public bool dirty { get; set; }
        public object[] alarms { get; set; }
        public string nozzleControlName { get; set; }
        public int photoId { get; set; }
        public long fixTime { get; set; }
        public long soldTime { get; set; }
        public object[] alarmDetail { get; set; }
        public long createdDate { get; set; }
        public int createdBy { get; set; }
        public long modifiedDate { get; set; }
        public int offlineAlarmLevel { get; set; }
        public string hdv { get; set; }
    }

    public class NozzleDisplaycontrol
    {
        public long onlineStatusDate { get; set; }
        public int deviceAlarmLevel { get; set; }
        public string onlineStatus { get; set; }
        public string uuid { get; set; }
        public string deviceStatus { get; set; }
        public int modifiedBy { get; set; }
        public long startTime { get; set; }
        public int alarmLevel { get; set; }
        public string sn { get; set; }
        public int id { get; set; }
        public int dispenserSupplierId { get; set; }
        public bool dirty { get; set; }
        public object[] alarms { get; set; }
        public string nozzleControlName { get; set; }
        public int photoId { get; set; }
        public long fixTime { get; set; }
        public string[] alarmDetail { get; set; }
        public long createdDate { get; set; }
        public int createdBy { get; set; }
        public long modifiedDate { get; set; }
        public int offlineAlarmLevel { get; set; }
    }

}
