﻿using FreeSql.DataAnnotations;
using IMES_Middleware_Platform.Api.Domain.FuelDispenser.Dto;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ZhonTai.Admin.Core.Entities;

namespace IMES_Middleware_Platform.Api.Domain.FuelDispenser
{
    /// <summary>
    /// 编码器
    /// </summary>
    [Table(Name = "EncoderControls")]
    public class EncoderControlsEntity : EntityAdd
    {
        /// <summary>
        /// 设备端告警等级 1代表一 般,2代表严重
        /// </summary>
        public int DeviceAlarmLevel { get; set; }

        /// <summary>
        /// 在线状态。
        /// </summary>
        public string OnlineStatus { get; set; }

        /// <summary>
        /// 签名验证状态。
        /// </summary>
        public bool SignVerify { get; set; }

        /// <summary>
        ///  UUID。
        /// </summary>
        public string Uuid { get; set; }

        /// <summary>
        /// 设备状态。
        /// </summary>
        public string DeviceStatus { get; set; }

        /// <summary>
        /// 供应商ID。
        /// </summary>
        public int? SupplierID { get; set; }

        /// <summary>
        /// 用户 ID。
        /// </summary>
        public int ModifiedBy { get; set; }

        /// <summary>
        /// 启用时间。
        /// </summary>
        public DateTime? StartTime { get; set; }

        /// <summary>
        /// 报警级别。
        /// </summary>
        public int AlarmLevel { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public int Id { get; set; }

        /// <summary>
        /// 加油机供应商 ID。
        /// </summary>
        public int DispenserSupplierId { get; set; }

        /// <summary>
        /// 是否未上报的疑似脏数据
        /// </summary>
        public bool Dirty { get; set; }

        /// <summary>
        /// 安装时间 。
        /// </summary>
        public DateTime? FixTime { get; set; }

        /// <summary>
        /// 报警详情
        /// </summary>
        public string AlarmDetail { get; set; }

        /// <summary>
        /// 创建日期。
        /// </summary>
        public DateTime? CreatedDate { get; set; }

        /// <summary>
        /// 用户 ID。
        /// </summary>
        public int CreatedBy { get; set; }

        /// <summary>
        /// 修改日期。
        /// </summary>
        public DateTime? ModifiedDate { get; set; }
        /// <summary>
        /// 微处理器编号
        /// </summary>
        public string CpuUuid { get; set; }
        /// <summary>
        /// 原厂编号
        /// </summary>
        public string SN { get; set; }
        /// <summary>
        /// 硬件版本号 
        /// </summary>
        public string Hdv { get; set; }
        /// <summary>
        /// 程序签名 
        /// </summary>
        public string Signature { get; set; }
        /// <summary>
        /// 编码器备案程序包 
        /// </summary>
        public string EncoderSoftware { get; set; }
        /// <summary>
        /// 安全装置ID 
        /// </summary>
        public int? BlackBoxID { get; set; }
        /// <summary>
        /// 站点id 
        /// </summary>
        public int? StationID { get; set; }
        /// <summary>
        /// 计量器id 
        /// </summary>
        public int? MeterID { get; set; }
        /// <summary>
        /// 生产时间 
        /// </summary>
        public DateTime? ProductTime { get; set; }
        /// <summary>
        /// 出厂时间 
        /// </summary>
        public DateTime? SoldTime { get; set; }
        /// <summary>
        /// 照片id  
        /// </summary>
        public long photoId { get; set; }
        /// <summary>
        /// 错误列表 
        /// </summary>
        public string Alarms { get; set; }
        /// <summary>
        /// 法制软件版本 
        /// </summary>
        public string lawSwv { get; set; }
        /// <summary>
        /// 法制软件标识 
        /// </summary>
        public string lawSwi { get; set; }
        /// <summary>
        /// 油机id
        /// </summary>
        public int? FuelId { get; set; }
    }
}
