﻿using FreeSql.DataAnnotations;
using IMES_Middleware_Platform.Api.Domain.FuelDispenser.Dto;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ZhonTai.Admin.Core.Entities;

namespace IMES_Middleware_Platform.Api.Domain.FuelDispenser
{
    /// <summary>
    /// 设备，监控微处理器、加密显示屏、编码器
    /// </summary>
    [Table(Name = "Equipment")]
    public class EquipmentEntity : EntityAdd
    {
        /// <summary>
        /// 设备类型   监控微处理器：monitoring，加密显示屏DisplayControls，编码器：encoderControls，油气回收：vaporRecoveryControl
        /// </summary>
        public string DeviceType { get; set; }
        /// <summary>
        /// 数量
        /// </summary>
        public int mainBoard { get; set; }
        /// <summary>
        /// 设备报警级别。
        /// </summary>
        public int DeviceAlarmLevel { get; set; }

        /// <summary>
        /// 在线状态。
        /// </summary>
        public string OnlineStatus { get; set; }

        /// <summary>
        /// UUID。
        /// </summary>
        public string Uuid { get; set; }

        /// <summary>
        /// 设备状态。
        /// </summary>
        public string DeviceStatus { get; set; }

        /// <summary>
        /// 加密显示屏供应商ID。
        /// </summary>
        public int? SupplierID { get; set; }

        /// <summary>
        /// 用户 ID。
        /// </summary>
        public int ModifiedBy { get; set; }

        /// <summary>
        /// 序列号。
        /// </summary>
        public string Sn { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public int Id { get; set; }

        /// <summary>
        /// 加油机供应商 ID。
        /// </summary>
        public int DispenserSupplierId { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public bool Dirty { get; set; }

        /// <summary>
        /// 油枪名称
        /// </summary>
        public string NozzleControlName { get; set; }

        /// <summary>
        /// 修复时间。
        /// </summary>
        public DateTime? FixTime { get; set; }


        /// <summary>
        /// 创建日期。
        /// </summary>
        public long CreatedDate { get; set; }

        /// <summary>
        /// 用户 ID。
        /// </summary>
        public int CreatedBy { get; set; }

        /// <summary>
        /// 修改日期。
        /// </summary>
        public long ModifiedDate { get; set; }

        /// <summary>
        /// 黑盒ID
        /// </summary>
        public int? BlackBoxID { get; set; }
        /// <summary>
        /// 油机ID
        /// </summary>
        public int FuelID { get; set; }
        /// <summary>
        /// 油枪id
        /// </summary>
        public int NozzleID { get; set; }
    }
}
