﻿using FreeSql.DataAnnotations;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Linq;
using ZhonTai.Admin.Core.Entities;

namespace IMES_Middleware_Platform.Api.Domain.FuelDispenser
{
    /// <summary>
    /// 加油机
    /// </summary>
    [Table(Name = "FuelDispenser")]
    public class FuelDispenserEntity : EntityUpdate
    {
        /// <summary>
        /// 加油机名称
        /// </summary>
        public string Name { get; set; }
        public int  FuelId { get; set; }

        /// <summary>
        /// 石油公司
        /// </summary>
        public string OilCompany { get; set; }

        /// <summary>
        /// 加油站
        /// </summary>
        public string GasStation { get; set; }

        /// <summary>
        /// 序列号
        /// </summary>
        public string SerialNumber { get; set; }

        /// <summary>
        /// 加油机机型
        /// </summary>
        public string Model { get; set; }

        /// <summary>
        /// 加油机枪数量
        /// </summary>
        public int GunCount { get; set; }

        /// <summary>
        /// 制造商
        /// </summary>
        public string Manufacturer { get; set; }
        /// <summary>
        /// 加油机厂商
        /// </summary>
        public string Description { get; set; }

        /// <summary>
        /// 出厂时间
        /// </summary>
        public DateTime? ManufactureDate { get; set; }

        /// <summary>
        /// 启动时间
        /// </summary>
        public DateTime? StartupDate { get; set; }

        /// <summary>
        /// 安装时间
        /// </summary>
        public DateTime? InstallationDate { get; set; }

        /// <summary>
        /// 设备状态
        /// </summary>
        public string DeviceStatus { get; set; }

        /// <summary>
        /// 在线状态
        /// </summary>
        public string OnlineStatus { get; set; }
        /// <summary>
        /// 测量范围
        /// </summary>
        public string MeasureRang { get; set; }
        /// <summary>
        /// 准确度等级
        /// </summary>
        public string AccuracyLevel { get; set; }
        /// <summary>
        /// 规格参数
        /// </summary>
        public string ModelSpec { get; set; }
        /// <summary>
        /// 报警状态  0:正常   1：一般报警    2：严重报警
        /// </summary>
        public int AlarmLevel { get; set; }
        /// <summary>
        /// 累计在线时间
        /// </summary>
        public string OnlineDesc { get; set; }
        /// <summary>
        /// 省份
        /// </summary>
        public string Province { get; set; }
        /// <summary>
        /// 版本号
        /// </summary>
        public int Version { get; set; }
        /// <summary>
        /// 修复时间
        /// </summary>
        public DateTime? FixTime { get; set; }
        /// <summary>
        /// 最后一次检查时间。
        /// </summary>
        public DateTime? LastInspectTime { get; set; }
        /// <summary>
        /// 维修
        /// </summary>
        public int Repairing { get; set; }
        /// <summary>
        /// 设置
        /// </summary>
        public string Setup { get; set; }
        /// <summary>
        /// UUID
        /// </summary>
        public string UUID { get; set; }
        /// <summary>
        /// 油站id
        /// </summary>
        public int StationId { get; set; }

        /// <summary>
        /// 供应商 ID。
        /// </summary>
        public int SupplierId { get; set; }
        /// <summary>
        /// 报警时间。
        /// </summary>
        public DateTime AlarmTime { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public int Alarming { get; set; }
        /// <summary>
        /// 锁定时间。
        /// </summary>
        public DateTime LockTime { get; set; }

        /// <summary>
        /// 是否被锁定。
        /// </summary>
        public int Lock { get; set; }

        /// <summary>
        /// 测试
        /// </summary>
        public int Test { get; set; }
        /// <summary>
        /// 联系方式
        /// </summary>
        public string Phone { get; set; }
        /// <summary>
        /// 联系人
        /// </summary>
        public string Contact { get; set; }
        /// <summary>
        /// 多个铅封号
        /// </summary>
        public string SealNo { get; set; }
        /// <summary>
        /// 多个附件
        /// </summary>
        public string photoIds { get; set; }
        /// <summary>
        /// 验证码
        /// </summary>
        public string VerificationCode { get; set; }
    }
}
