﻿using FreeSql.DataAnnotations;
using IMES_Middleware_Platform.Api.Domain.FuelDispenser.Dto;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ZhonTai.Admin.Core.Entities;

namespace IMES_Middleware_Platform.Api.Domain.FuelDispenser
{
    /// <summary>
    /// 维修记录
    /// </summary>
    [Table(Name = "Maintenance")]
    public class MaintenanceEntity : EntityAdd
    {
        /// <summary>
        /// 维修时间（Unix时间戳）
        /// <remarks>精确到毫秒</remarks>
        /// </summary>
        public long CreatedDate { get; set; }

        /// <summary>
        /// 维修人员唯一标识
        /// <remarks>关联人员管理系统ID</remarks>
        /// </summary>
        public long CreatedBy { get; set; }

        /// <summary>
        /// 维修状态
        /// <seealso cref="MaintenanceStatus"/>
        /// </summary>
        public string Status { get; set; }

        /// <summary>
        /// 维修类型
        /// <seealso cref="MaintenanceType"/>
        /// </summary>
        public string Type { get; set; }

        /// <summary>
        /// 维修描述
        /// <remarks>最大长度500字符</remarks>
        /// </summary>
        public string Description { get; set; }

        /// <summary>
        /// 油机id
        /// <seealso cref="Dispenser"/>
        /// <remarks>当维修类型为油机时必填</remarks>
        /// </summary>
        public int? FuelId{ get; set; }

        /// <summary>
        /// 站点id
        /// <seealso cref="Station"/>
        /// </summary>
        public int  StationID { get; set; }
    }
}
