﻿using FreeSql.DataAnnotations;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ZhonTai.Admin.Core.Entities;

namespace IMES_Middleware_Platform.Api.Domain.FuelDispenser
{
    /// <summary>
    /// 油枪
    /// </summary>
    [Table(Name = "Nozzlecontrol")]
    public class NozzlecontrolEntity : EntityAdd
    {
        public int NozzleID { get; set; }
        /// <summary>
        /// 油机ID
        /// </summary>
        public int FuelId { get; set; }
        /// <summary>
        /// ECQS编码
        /// </summary>
        public string Code { get; set; }
        /// <summary>
        /// 油品
        /// </summary>
        public string FuelName { get; set; }
        /// <summary>
        /// 油枪逻辑编号
        /// </summary>
        public string Name { get; set; }
        /// <summary>
        /// 主板数
        /// </summary>
        public int? MainBoard { get; set; }
        /// <summary>
        /// 枪数
        /// </summary>
        public int? NozzleNo { get; set; }
        /// <summary>
        /// 在线状态
        /// </summary>
        public string OnlineStatus { get; set; }
        /// <summary>
        /// 自锁功能
        /// </summary>
        public bool Alarming { get; set; }

        /// <summary>
        /// 设备是否隐藏。
        /// </summary>
        public bool Hidden { get; set; }

        /// <summary>
        /// 设备报警级别。
        /// </summary>
        public int DeviceAlarmLevel { get; set; }


        /// <summary>
        /// 设备类型。
        /// </summary>
        public string IotType { get; set; }

        /// <summary>
        /// 出厂时间
        /// </summary>
        public DateTime? ProductTime { get; set; }

        /// <summary>
        /// 设备状态。
        /// </summary>
        public string DeviceStatus { get; set; }

        /// <summary>
        /// 修改设备用户id
        /// </summary>
        public int ModifiedBy { get; set; }

        /// <summary>
        /// 启用时间
        /// </summary>
        public DateTime? StartTime { get; set; }

        /// <summary>
        /// 编码器ID
        /// </summary>
        public int? EncoderControlsID { get; set; }

        /// <summary>
        /// 报警级别。
        /// </summary>
        public int AlarmLevel { get; set; }

        /// <summary>
        /// 设备运行状态
        /// </summary>
        public string Value { get; set; }

        /// <summary>
        /// 加密显示屏ID
        /// </summary>
        public int? DisplayControlsID { get; set; }
        /// <summary>
        /// 监控微处理器ID
        /// </summary>
        public int? MonitoringID { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public bool Dirty { get; set; }

        /// <summary>
        /// 恢复状态。
        /// </summary>
        public string Recover { get; set; }


        /// <summary>
        /// 修复时间。
        /// </summary>
        public DateTime? FixTime { get; set; }

        /// <summary>
        /// 油气回收ID
        /// </summary>
        public int? VaporRecoveryControlID { get; set; }

        /// <summary>
        /// 销售时间
        /// </summary>
        public DateTime? SoldTime { get; set; }

        /// <summary>
        /// 创建日期
        /// </summary>
        public DateTime? CreatedDate { get; set; }

        /// <summary>
        /// 安全监督装置ID
        /// </summary>
        public int? BlackBoxID { get; set; }

        /// <summary>
        /// 创建人ID
        /// </summary>
        public int CreatedBy { get; set; }


        /// <summary>
        /// 修改日期
        /// </summary>
        public long ModifiedDate { get; set; }

        /// <summary>
        /// 作弊状态
        /// </summary>
        public string CheatStatus { get; set; }
        /// <summary>
        /// 加油站
        /// </summary>
        public string GasStation { get; set; }
        /// <summary>
        /// 供应商名称
        /// </summary>
        public string SupplierName { get; set; }
        /// <summary>
        /// 石油公司
        /// </summary>
        public string CompanyName { get; set; }
        /// <summary>
        /// 监控微处理器编号
        /// </summary>
        public string MonitoringNo { get; set; }
        /// <summary>
        /// 加密显示屏编号
        /// </summary>
        public string DisplayControlsNo { get; set; }
        /// <summary>
        /// 编码器编号
        /// </summary>
        public string EncoderControlsNo { get; set; }
        /// <summary>
        /// 监控微处理器错误列表
        /// </summary>
        public string TaxAlarms { get; set; }
        /// <summary>
        /// 站点id
        /// </summary>
        public int? StationID { get; set; }
        /// <summary>
        /// 厂商ID
        /// </summary>
        public int SupplierID { get; set; }
        /// <summary>
        /// 计量器ID
        /// </summary>
        public int MetersID { get; set; }
        /// <summary>
        /// 智能控制阀ID
        /// </summary>
        public int ValveControlsID { get; set; }
        /// <summary>
        /// 监控微处理器ID
        /// </summary>
        public int TaxControlID { get; set; }
    }
}
