﻿using FreeSql.DataAnnotations;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ZhonTai.Admin.Core.Entities;

namespace IMES_Middleware_Platform.Api.Domain.FuelDispenser
{
    /// <summary>
    /// 油站
    /// </summary>
    [Table(Name = "Station")]
    public class StationEntity : EntityAdd
    {
        /// <summary>
        /// 是否有生效中的告警。
        /// </summary>
        public bool Alarming { get; set; }

        /// <summary>
        /// 区县编码。
        /// </summary>
        public string DistrictCode { get; set; }

        /// <summary>
        ///城市名称。
        /// </summary>
        public string City { get; set; }

        /// <summary>
        /// 城市编码。
        /// </summary>
        public string CityCode { get; set; }

        /// <summary>
        ///加油站类型。
        /// </summary>
        public string Type { get; set; }

        /// <summary>
        /// 注册号。
        /// </summary>
        public string RegisterNo { get; set; }

        /// <summary>
        /// 省份。
        /// </summary>
        public string Province { get; set; }

        /// <summary>
        /// 联系人。
        /// </summary>
        public string Contact { get; set; }

        /// <summary>
        /// 用户 ID。
        /// </summary>
        public int ModifiedBy { get; set; }
        /// <summary>
        /// 纬度。
        /// </summary>
        public double Lat { get; set; }

        /// <summary>
        /// 详细地址。
        /// </summary>
        public string Address { get; set; }

        /// <summary>
        /// 经度。
        /// </summary>
        public double Lng { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public bool Test { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public bool Business { get; set; }

        /// <summary>
        /// 省份编码。
        /// </summary>
        public string ProvinceCode { get; set; }

        /// <summary>
        /// 报警时间。
        /// </summary>
        public DateTime? AlarmTime { get; set; }

        /// <summary>
        /// 加油机总数。
        /// </summary>
        public int DispensersTotal { get; set; }

        /// <summary>
        /// 创建日期。
        /// </summary>
        public DateTime? CreatedDate { get; set; }

        /// <summary>
        /// 联系电话。
        /// </summary>
        public string Phone { get; set; }

        /// <summary>
        /// 用户 ID。
        /// </summary>
        public int CreatedBy { get; set; }

        /// <summary>
        /// 区县名称。
        /// </summary>
        public string District { get; set; }

        /// <summary>
        /// 加油站名称。
        /// </summary>
        public string Name { get; set; }

        /// <summary>
        /// 修改日期。
        /// </summary>
        public long ModifiedDate { get; set; }

        /// <summary>
        /// 通知总数。
        /// </summary>
        public int NoticesTotal { get; set; }

        /// <summary>
        /// 油枪总数。
        /// </summary>
        public int NozzleControlsTotal { get; set; }
        /// <summary>
        /// 公司ID
        /// </summary>
        public int CompanyID { get; set; }
        /// <summary>
        /// 油站编号
        /// </summary>
        public string StationCode { get; set; }
        /// <summary>
        /// 照片ID
        /// </summary>
        public long PhotoId { get; set; }
        /// <summary>
        /// 描述
        /// </summary>
        public string Description { get; set; }
        /// <summary>
        /// 纳税人识别号
        /// </summary>
        public string registerNo { get; set; }
        /// <summary>
        /// 是否有生效的标签
        /// </summary>
        public string tags { get; set; }
        /// <summary>
        /// 归属质监局
        /// </summary>
        public int supervision { get; set; }
        /// <summary>
        /// 站点id
        /// </summary>
        public int StationID { get; set; }
    }
}
