﻿using FreeSql.DataAnnotations;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ZhonTai.Admin.Core.Entities;

namespace IMES_Middleware_Platform.Api.Domain.FuelDispenser
{
    /// <summary>
    /// 供应商
    /// </summary>
    [Table(Name = "Supplier")]
    public class SupplierEntity : EntityAdd
    {
        /// <summary>
        /// 供应商类型。
        /// </summary>
        public string GroupType { get; set; }

        /// <summary>
        /// 供应商代码。
        /// </summary>
        public string Code { get; set; }

        /// <summary>
        ///
        /// </summary>
        public int StandardId { get; set; }

        /// <summary>
        /// 描述。
        /// </summary>
        public string Description { get; set; }


        /// <summary>
        /// 注册编号。
        /// </summary>
        public string RegisterNo { get; set; }

        /// <summary>
        /// 创建日期。
        /// </summary>
        public long CreatedDate { get; set; }

        /// <summary>
        /// 设备类型列表。
        /// </summary>
        public string DeviceTypes { get; set; }

        /// <summary>
        /// 用户 ID。
        /// </summary>
        public int CreatedBy { get; set; }

        /// <summary>
        /// 供应商名称。
        /// </summary>
        public string Name { get; set; }

        /// <summary>
        /// 修改日期。
        /// </summary>
        public long ModifiedDate { get; set; }

        /// <summary>
        /// 别名。
        /// </summary>
        public string Alias { get; set; }

        /// <summary>
        /// 用户 ID。
        /// </summary>
        public int ModifiedBy { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public int Id { get; set; }
    }
}
