﻿using FreeSql.DataAnnotations;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ZhonTai.Admin.Core.Entities;

namespace IMES_Middleware_Platform.Api.Domain.FuelDispenser
{
    /// <summary>
    /// 监控微处理器
    /// </summary>
    [Table(Name = "TaxControl")]
    public class TaxControlEntity : EntityAdd
    {
        /// <summary>
        /// 主板Id
        /// </summary>
        public int MainBoard { get; set; }

        /// <summary>
        /// 重置次数。
        /// </summary>
        public int ResetTimes { get; set; }

        /// <summary>
        /// 设备端告警等级 1代表一 般,2代表严重
        /// </summary>
        public int DeviceAlarmLevel { get; set; }

        /// <summary>
        /// 在线状态。
        /// </summary>
        public string OnlineStatus { get; set; }

        /// <summary>
        ///  UUID。
        /// </summary>
        public string Uuid { get; set; }

        /// <summary>
        /// 签名验证状态。
        /// </summary>
        public bool SignVerify { get; set; }

        /// <summary>
        /// 设备状态。
        /// </summary>
        public string DeviceStatus { get; set; }

        /// <summary>
        /// 用户 ID。
        /// </summary>
        public int ModifiedBy { get; set; }

        /// <summary>
        /// 报警级别。
        /// </summary>
        public int AlarmLevel { get; set; }

        /// <summary>
        /// id
        /// </summary>
        public int Id { get; set; }

        /// <summary>
        ///供应商 ID
        /// </summary>
        public int DispenserSupplierId { get; set; }

        /// <summary>
        /// 是否未上报的疑似脏数据
        /// </summary>
        public bool Dirty { get; set; }

        /// <summary>
        /// 错误列表
        /// </summary>
        public string Alarms { get; set; }

        /// <summary>
        /// 油枪号 9;12;10;11;
        /// </summary>
        public string NozzleControlName { get; set; }


        /// <summary>
        /// 安装时间。
        /// </summary>
        public DateTime? FixTime { get; set; }


        /// <summary>
        /// 创建日期。
        /// </summary>
        public long CreatedDate { get; set; }

        /// <summary>
        /// 用户 ID。
        /// </summary>
        public int CreatedBy { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public long ModifiedDate { get; set; }
        /// <summary>
        /// 油机ID
        /// </summary>
        public int FuelID { get; set; }
        /// <summary>
        /// 油枪逻辑编号
        /// </summary>
        public string Name { get; set; }
        /// <summary>
        /// 油枪物理Id
        /// </summary>
        public string NozzleNo { get; set; }
        /// <summary>
        /// 防作弊状 态:enable-启用 disable-停用
        /// </summary>
        public string CheatStatus { get; set; }
        /// <summary>
        /// 油气回收认证等级:signed-带签名enable- 仅硬件disable未启用
        /// </summary>
        public string Recover { get; set; }
        /// <summary>
        /// 智能型控制阀认证等级:signed-带签名enable- 仅硬件disable非智能
        /// </summary>
        public string Value { get; set; }
        /// <summary>
        /// 是否隐藏
        /// </summary>
        public string Hidden { get; set; }
        /// <summary>
        /// 监控微处理器错误列表
        /// </summary>
        public string TaxAlarms { get; set; }
        /// <summary>
        /// 机型配置
        /// </summary>
        public string IotType { get; set; }
        /// <summary>
        /// 安全装置ID
        /// </summary>
        public int? BlackBoxID { get; set; }
        /// <summary>
        /// 站点id
        /// </summary>
        public int? StationID { get; set; }
        /// <summary>
        /// 油品名称
        /// </summary>
        public string FuelName { get; set; }
        /// <summary>
        /// e-CQS编码
        /// </summary>
        public string Code { get; set; }
        /// <summary>
        ///生产时间 
        /// </summary>
        public DateTime? ProductTime { get; set; }
        /// <summary>
        ///出厂时间  
        /// </summary>
        public DateTime? SoldTime { get; set; }
        /// <summary>
        ///启用时间 
        /// </summary>
        public DateTime? StartTime { get; set; }
    }
}
