﻿using FreeSql.DataAnnotations;
using IMES_Middleware_Platform.Api.Domain.FuelDispenser.Dto;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ZhonTai.Admin.Core.Entities;

namespace IMES_Middleware_Platform.Api.Domain.FuelDispenser
{
    /// <summary>
    /// 智能型控制阀
    /// </summary>
    [Table(Name = "ValveControl")]
    public class ValveControlEntity : EntityAdd
    {
        /// <summary>
        /// 唯一ID (0-32)
        /// </summary>
        public string Uuid { get; set; }
        /// <summary>
        /// 软件版本号 (0-32)
        /// </summary>
        public string Swv { get; set; }
        /// <summary>
        /// 硬件版本号 (0-32)
        /// </summary>
        public string Hdv { get; set; }
        /// <summary>
        ///  国密芯片ID (0-32)
        /// </summary>
        public string SecCpuUuid { get; set; }
        /// <summary>
        ///  油机供应商ID
        /// </summary>
        public long DispenserSupplierId { get; set; }
        /// <summary>
        ///  是否未上报的疑似脏数据
        /// </summary>
        public bool Dirty { get; set; }
        /// <summary>
        /// 程序签名 (0-256)
        /// </summary>
        public string Signature { get; set; }
        /// <summary>
        /// 验签结果
        /// </summary>
        public bool SignVerify { get; set; }
        /// <summary>
        /// 智能型控制阀备案程序包
        /// </summary>
        public string ValveSoftware { get; set; }
        /// <summary>
        /// 安全装置
        /// </summary>
        public int BlackBoxID { get; set; }
        /// <summary>
        /// 站点
        /// </summary>
        public int StationID { get; set; }
        /// <summary>
        /// 供应商
        /// </summary>
        public int SupplierID { get; set; }
        /// <summary>
        /// online/offline状态
        /// </summary>
        public string OnlineStatus { get; set; }
        /// <summary>
        /// 设备状态
        /// </summary>
        public string DeviceStatus { get; set; }
        /// <summary>
        ///  设备端告警等级(1-一般,2-严重)
        /// </summary>
        public int DeviceAlarmLevel { get; set; }
        /// <summary>
        /// 生产时间
        /// </summary>
        public DateTime? ProductTime { get; set; }
        /// <summary>
        /// 出厂时间(可为空)
        /// </summary>
        public DateTime? SoldTime { get; set; }
        /// <summary>
        /// 启用时间(可为空)
        /// </summary>
        public DateTime? StartTime { get; set; }
        /// <summary>
        /// 照片ID(可为空)
        /// </summary>
        public long? PhotoId { get; set; }
        /// <summary>
        ///  安装时间(可为空)
        /// </summary>
        public DateTime? FixTime { get; set; }
        /// <summary>
        /// 错误列表
        /// </summary>
        public string Alarms { get; set; }
        /// <summary>
        /// 法制软件版本
        /// </summary>
        public string LawSwv { get; set; }
        /// <summary>
        /// 法制软件标识
        /// </summary>
        public string LawSwi { get; set; } 
    }
}
