﻿using FreeSql.DataAnnotations;
using IMES_Middleware_Platform.Api.Domain.FuelDispenser.Dto;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ZhonTai.Admin.Core.Entities;

namespace IMES_Middleware_Platform.Api.Domain.FuelDispenser
{
    /// <summary>
    /// 油气回收控制板
    /// </summary>
    [Table(Name = "VaporRecoveryControl")]
    public class VaporRecoveryControlEntity : EntityAdd
    {
        /// <summary>
        /// 设备唯一标识符 (0-32字符)
        /// </summary>
        public string Uuid { get; set; }

        /// <summary>
        /// 软件版本号 (0-32字符)
        /// </summary>
        public string Swv { get; set; }

        /// <summary>
        /// 硬件版本号 (0-32字符)
        /// </summary>
        public string Hdv { get; set; }

        /// <summary>
        /// 国密安全芯片唯一标识 (0-32字符)
        /// </summary>
        public string SecCpuUuid { get; set; }

        /// <summary>
        /// 供应商ID
        /// </summary>
        public long DispenserSupplierId { get; set; }

        /// <summary>
        /// 标识是否存在未上报的疑似脏数据
        /// </summary>
        public bool Dirty { get; set; }

        /// <summary>
        /// 程序签名数据 (0-256字符)
        /// </summary>
        public string Signature { get; set; }

        /// <summary>
        /// 签名验证结果
        /// </summary>
        public bool SignVerify { get; set; }

        /// <summary>
        /// 油气回收控制板备案程序包信息
        /// </summary>
        public string VaporRecoverySoftware { get; set; }

        /// <summary>
        /// 安全装置id
        /// </summary>
        public int? BlackBoxID { get; set; }

        /// <summary>
        /// 站点id
        /// </summary>
        public int? StationID { get; set; }

        /// <summary>
        /// 供应商ID
        /// </summary>
        public int? SupplierID { get; set; }

        /// <summary>
        /// 设备在线状态
        /// </summary>
        public string OnlineStatus { get; set; }

        /// <summary>
        /// 设备注册/绑定状态
        /// </summary>
        public string DeviceStatus { get; set; }

        /// <summary>
        /// 设备告警等级 (1-一般告警，2-严重告警)
        /// </summary>
        public int DeviceAlarmLevel { get; set; }

        /// <summary>
        /// 设备生产日期
        /// </summary>
        public DateTime? ProductTime { get; set; }

        /// <summary>
        /// 设备出厂日期
        /// </summary>
        public DateTime? SoldTime { get; set; }

        /// <summary>
        /// 设备启用日期
        /// </summary>
        public DateTime? StartTime { get; set; }

        /// <summary>
        /// 设备安装日期
        /// </summary>
        public DateTime? FixTime { get; set; }

        /// <summary>
        /// 设备照片存储ID
        /// </summary>
        public long? PhotoId { get; set; }

        /// <summary>
        /// 设备错误代码集合
        /// </summary>
        public string Alarms { get; set; }

        /// <summary>
        /// 法制软件版本号
        /// </summary>
        public string LawSwv { get; set; }

        /// <summary>
        /// 法制软件标识
        /// </summary>
        public string LawSwi { get; set; }
    }
}
