﻿using FreeSql.DataAnnotations;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ZhonTai.Admin.Core.Entities;

namespace IMES_Middleware_Platform.Api.Domain.Push
{
    /// <summary>
    /// 推送规则
    /// </summary>
    [Table(Name = "PushRule")]
    public class PushRuleEntity : EntityAdd
    {
        /// <summary>
        /// 规则名称
        /// </summary>
        public string RuleName { get; set; }
        /// <summary>
        ///  角色中间表id
        /// </summary>
        public long RoleMappingId { get; set; }
        /// <summary>
        /// 推送用户中间表id
        /// </summary>
        public long PushUserid { get; set; }
        /// <summary>
        /// 备注
        /// </summary>
        public string Remark { get; set; }
        /// <summary>
        /// 推送方式
        /// </summary>
        public string PushMethod { get; set; }
        /// <summary>
        /// 触发方式
        /// </summary>
        public string TriggerMethod { get; set; }
        /// <summary>
        ///  规则条件
        /// </summary>
        public string ConditionsJson { get; set; }
        /// <summary>
        /// 是否启用
        /// </summary>
        public bool IsActive { get; set; }
        /// <summary>
        ///  启用时间
        /// </summary>
        public DateTime? ActivationTime { get; set; }
        /// <summary>
        /// 停用时间
        /// </summary>
        public DateTime? DeactivationTime { get; set; }
        /// <summary>
        /// 模板中间表ID
        /// </summary>
        public long PushTemplateMappingID { get; set; }
        /// <summary>
        /// 正则表达式
        /// </summary>
        public string Regular { get; set; }
        /// <summary>
        /// 是否互斥
        /// </summary>
        public bool IsExclusive { get; set; }
        /// <summary>
        /// 优先级
        /// </summary>
        public int? TaskPriority { get; set; }
    }
}
