﻿using Core.Service_Middleware_Platform.Api.Core;
using DotNetCore.CAP.Internal;
using IdentityModel;
using IMES_Middleware_Platform.Api.Core.Consts;
using IMES_Middleware_Platform.Api.Core.Handlers;
using IMES_Middleware_Platform.Api.Core.Utility;
using IMES_Middleware_Platform.Api.Domain.FuelDispenser;
using IMES_Middleware_Platform.Api.Domain.FuelDispenser.Dto;
using IMES_Middleware_Platform.Api.Domain.Push;
using IMES_Middleware_Platform.Api.Domain.Push.Dto;
using IMES_Middleware_Platform.Api.Repositories.Push;
using IMES_Middleware_Platform.Api.Services.Module;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Configuration;
using Newtonsoft.Json.Linq;
using SixLabors.ImageSharp.Drawing;
using SixLabors.ImageSharp.Metadata.Profiles.Exif;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics.Metrics;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Reactive;
using System.Reactive.Joins;
using System.Security.Cryptography;
using System.Text;
using System.Text.Json;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Xml.Linq;
using ZhonTai.Admin.Core.Configs;
using ZhonTai.Admin.Core.Db;
using ZhonTai.Admin.Core.Entities;
using ZhonTai.Admin.Core.Logs;
using ZhonTai.Admin.Services;
using ZhonTai.Common.Helpers;
using ZhonTai.DynamicApi;
using ZhonTai.DynamicApi.Attributes;
using static COSXML.Model.Tag.ListBucketVersions;
using static System.Collections.Specialized.BitVector32;

namespace IMES_Middleware_Platform.Api.Services.Association
{
    [Order(1010)]
    [DynamicApi(Area = ApiConsts.AreaName)]
    public class AssociationService : BaseService, IAssociationService, IDynamicApi
    {
        private readonly IConfiguration _configuration;
        public readonly IFuelDispenserRepository _fuelDispenserRepository;
        public readonly IAlarmHistoryRepository _alarmHistoryRepository;
        public readonly ILifeCycleRepository _lifeCycleRepository;
        public readonly INozzlecontrolRepository _nozzlecontrolRepository;
        public readonly IEquipmentRepository _equipmentRepository;
        public readonly IAssociationUserRepository _associationUserRepository;
        public readonly IStationRepository _stationRepository;

        public readonly IPushRepository _pushRepository;
        public readonly IPushRuleRepository _pushRuleRepository;
        public readonly IPushTemplateRepository _pushTemplateRepository;
        public readonly IPushTemplateMappingRepository _pushTemplateMappingRepository;
        public readonly IRoleMappingRepository _roleMappingRepository;

        public readonly IUserRepository _userRepository;
        public readonly IUserPoleRepository _userPoleRepository;

        public readonly IBlackBoxRepository _blackBoxRepository;
        public readonly ICalculatorMainboardRepository _calculatorMainboardRepository;
        public readonly ICompanyRepository _companyRepository;
        public readonly IDisplayControlRepository _displayControlRepository;
        public readonly IEncoderControlsRepository _encoderControlsRepository;
        public readonly IMaintenanceRepository _maintenanceRepository;
        public readonly IMeterRepository _meterRepository;
        public readonly ISupplierRepository _supplierRepository;
        public readonly ITaxControlRepository _taxControlRepository;
        public readonly IValveControlRepository _valveControlRepository;
        public readonly IVaporRecoveryControlRepository _vaporRecoveryControlRepository;

        static string token = string.Empty;
        public AssociationService(IConfiguration configuration
        , IFuelDispenserRepository fuelDispenserRepository
        , IAlarmHistoryRepository alarmHistoryRepository
        , ILifeCycleRepository lifeCycleRepository
        , INozzlecontrolRepository nozzlecontrolRepository
        , IEquipmentRepository equipmentRepository,
        IAssociationUserRepository associationUserRepository,
        IStationRepository stationRepository,
        IPushRepository pushRepository,
        IPushRuleRepository pushRuleRepository,
        IPushTemplateRepository pushTemplateRepository,
        IPushTemplateMappingRepository pushTemplateMappingRepository,
        IRoleMappingRepository roleMappingRepository,
        IUserRepository userRepository,
        IUserPoleRepository userPoleRepository,
        IBlackBoxRepository blackBoxRepository,
        ICalculatorMainboardRepository calculatorMainboardRepository,
        ICompanyRepository companyRepository,
        IDisplayControlRepository displayControlRepository,
        IEncoderControlsRepository encoderControlsRepository,
        IMaintenanceRepository maintenanceRepository,
        IMeterRepository meterRepository,
        ISupplierRepository supplierRepository,
        ITaxControlRepository taxControlRepository,
        IValveControlRepository valveControlRepository,
        IVaporRecoveryControlRepository vaporRecoveryControlRepository
        )
        {
            _configuration = configuration;
            _fuelDispenserRepository = fuelDispenserRepository;
            _alarmHistoryRepository = alarmHistoryRepository;
            _lifeCycleRepository = lifeCycleRepository;
            _nozzlecontrolRepository = nozzlecontrolRepository;
            _equipmentRepository = equipmentRepository;
            _associationUserRepository = associationUserRepository;
            _stationRepository = stationRepository;
            _pushRepository = pushRepository;
            _pushRuleRepository = pushRuleRepository;
            _pushTemplateRepository = pushTemplateRepository;
            _roleMappingRepository = roleMappingRepository;
            _pushTemplateMappingRepository = pushTemplateMappingRepository;
            _userRepository = userRepository;
            _userPoleRepository = userPoleRepository;
            _blackBoxRepository = blackBoxRepository;
            _calculatorMainboardRepository = calculatorMainboardRepository;
            _companyRepository = companyRepository;
            _displayControlRepository = displayControlRepository;
            _encoderControlsRepository = encoderControlsRepository;
            _maintenanceRepository = maintenanceRepository;
            _meterRepository = meterRepository;
            _supplierRepository = supplierRepository;
            _taxControlRepository = taxControlRepository;
            _valveControlRepository = valveControlRepository;
            _vaporRecoveryControlRepository = vaporRecoveryControlRepository;
        }

        public Task<LocalApiDto> GetAllStation(string areaType, string search)
        {

            throw new NotImplementedException();
        }
        /// <summary>
        /// 加油机统计
        /// </summary>
        /// <param name="user"></param>
        /// <returns></returns>
        [HttpPost]
        public async Task GetDispensersAsync(string expand1, string expand2, string search, string token)
        {
            HttpHelper helper = new HttpHelper();
            string postUrl = "https://cma-fds.org.cn/api/v1/dispensers";
            var size = 20;
            var page = 0;
            await GetAllDataAsync(postUrl, token, expand1, expand2, search, size);
        }
        [HttpPost]
        public async Task<UserResponseDto> GetTokenAsync(UserLogin user)
        {
            HttpHelper helper = new HttpHelper();
            var middleAppConfig = ConfigHelper.Get<MiddleAppConfig>("appconfig");
            if (middleAppConfig.IsDevLogin)
            {
                user = user.TestLogin();

            }
            var json = JsonSerializer.Serialize(new
            {
                email = user.Email,
                mobile = user.Mobile,
                name = user.Name,
                password = user.Password
            });
            string postUrl = "https://cma-fds.org.cn/api/v1/users/login";
            HttpContent postContent = new StringContent(json, Encoding.UTF8, "application/json");
            string postResponse = await helper.PostAsync(postUrl, postContent);
            UserResponseDto myObject = Newtonsoft.Json.JsonConvert.DeserializeObject<UserResponseDto>(postResponse);
            token = myObject.Token;
            return myObject;
        }
        /// <summary>
        /// 电子档案
        /// </summary>
        /// <param name="postUrl"></param>
        /// <param name="token"></param>
        /// <param name="expand1"></param>
        /// <param name="expand2"></param>
        /// <param name="search"></param>
        /// <param name="pageSize"></param>
        /// <returns></returns>
        public async Task GetAllDataAsync(string postUrl, string token, string expand1, string expand2, string search, int pageSize)
        {
            int currentPage = 0;
            HttpHelper helper = new HttpHelper();
            while (true)
            {
                string result = await helper.GetDispensersDataAsync(postUrl, token, "", expand1, expand2, search, pageSize, currentPage);

                Root myObject = Newtonsoft.Json.JsonConvert.DeserializeObject<Root>(result);

                if (myObject == null || myObject.Content == null || myObject.Content.Count == 0)
                {
                    break;
                }

                await AddFuelDispenserAsync(myObject);

                // 增加当前页数
                currentPage++;
            }

        }
        /// <summary>
        /// 获取生命周期
        /// </summary>
        /// <returns></returns>
        public async Task GetLifecycleAsync(int id)
        {
            try
            {
                string jsonString = @"
        [
            {
                ""启用"": [
                    [""disable"", ""enable""],
                    [""bind"", ""enable""]
                ]
            },
            {
                ""维修"": [
                    [""enable"", ""disable""],
                    [""bind"", ""disable""]
                ]
            },
            {
                ""加油站注册"": [
                    [""factory"", ""bind""]
                ]
            },
            {
                ""出厂注册"": [
                    [""register"", ""factory""],
                    [""bind"", ""factory""]
                ]
            }
        ]";
                JArray jsonArray = JArray.Parse(jsonString);
                int currentPage = 0;
                int pageSize = 20;
                HttpHelper helper = new HttpHelper();
                List<LifecycleDto> list = new List<LifecycleDto>();
                List<int> intList = new List<int>();
                while (true)
                {
                    string result = await helper.GetLifecycleAsync("https://cma-fds.org.cn/api/v1/audits?", token, id, pageSize, currentPage);
                    LifecycleRoot myObject = Newtonsoft.Json.JsonConvert.DeserializeObject<LifecycleRoot>(result);
                    if (myObject == null || myObject.Content == null || myObject.Content.Count == 0)
                    {
                        break;
                    }
                    for (var i = 0; i < myObject.Content.Count(); i++)
                    {
                        DateTime? CreatedDate = myObject.Content[i].CreatedDate.HasValue
      ? DateTimeOffset.FromUnixTimeMilliseconds(myObject.Content[i].CreatedDate.Value).UtcDateTime
      : (DateTime?)null;
                        var device = myObject.Content[i].Content.DeviceStatus;
                        string keyName = string.Empty;
                        if (device is string)
                        {
                            // 处理字符串类型
                            keyName = ((string)device) == "register" ? "备案" : "";
                            // 进行相应的操作
                        }
                        else if (device is JArray)
                        {
                            // 处理字符串数组类型
                            JArray statusArray = (JArray)device;
                            foreach (JObject item in jsonArray)
                            {
                                foreach (var kvp in item)
                                {
                                    //keyName = kvp.Key;

                                    JArray innerArray = (JArray)kvp.Value;
                                    foreach (JArray subArray in innerArray)
                                    {
                                        // Compare each element in the subArray with statusArray
                                        bool isEqual = JArray.DeepEquals(subArray, statusArray);
                                        if (isEqual)
                                        {
                                            keyName = kvp.Key;
                                        }
                                    }
                                }
                            }
                        }
                        LifecycleDto lifecycleDto = new LifecycleDto()
                        {
                            CreatedDate = CreatedDate,
                            FuelId = id,
                            Operation = keyName,
                            Operator = myObject.Content[i].CreatedBy.Name,
                            OperatorID = myObject.Content[i].CreatedBy.Id,
                            LifeCycleID = myObject.Content[i].Id
                        };
                        list.Add(lifecycleDto);
                        intList.Add(lifecycleDto.LifeCycleID);
                    }
                    // 增加当前页数
                    currentPage++;
                }
                var lifeCycle = _lifeCycleRepository.Where(x => intList.Contains(x.LifeCycleID)).ToList();
                lifeCycle.ForEach(a =>
                {
                    list.RemoveAll(e => e.LifeCycleID == a.LifeCycleID);
                });
                if (list != null)
                {
                    await _lifeCycleRepository.InsertAsync(LifecycleDto.ToFuelDispenserList(list));
                }
            }
            catch (Exception ex)
            {

            }
        }
        /// <summary>
        /// 获取报警历史
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public async Task GetAlarmHistoryAsync(int id)
        {
            try
            {

                int currentPage = 0;
                int pageSize = 20;
                HttpHelper helper = new HttpHelper();
                List<int> intList = new List<int>();
                List<AlarmHistoryDto> historyDtos = new List<AlarmHistoryDto>();
                while (true)
                {
                    string result = await helper.GetAlarmHistoryAsync("https://cma-fds.org.cn/api/v1/notices?", token, id, pageSize, currentPage);
                    AlarmHistoryRoot myObject = Newtonsoft.Json.JsonConvert.DeserializeObject<AlarmHistoryRoot>(result);
                    if (myObject == null || myObject.Content == null || myObject.Content.Count == 0)
                    {
                        break;
                    }
                    for (var i = 0; i < myObject.Content.Count(); i++)
                    {
                        string origin = myObject.Content[i].origin;
                        DateTime? CreatedDate = myObject.Content[i].createdDate.HasValue
            ? DateTimeOffset.FromUnixTimeMilliseconds(myObject.Content[i].createdDate.Value).UtcDateTime
            : (DateTime?)null;
                        AlarmHistoryDto alarmHistoryDto = new AlarmHistoryDto
                        {
                            FuelId = id,
                            GasStation = myObject.Content[i].Station?.Name,
                            AlarmDescription = myObject.Content[i].Alarm?.description,
                            AlarmSource = origin == "blackBox" ? "安全装置" : origin == "platform" ? "云平台" : null,
                            SerialNumber = myObject.Content[i].dispenser.SerialNum,
                            AlarmType = myObject.Content[i].Alarm?.type,
                            CreatedDate = CreatedDate,
                            Name = myObject.Content[i].dispenser.Name,
                            AlarmHistoryID = myObject.Content[i].id
                        };
                        historyDtos.Add(alarmHistoryDto);
                        intList.Add(alarmHistoryDto.AlarmHistoryID);

                    }
                    // 增加当前页数
                    currentPage++;
                }
                var alarmHistory = _alarmHistoryRepository.Where(x => intList.Contains(x.AlarmHistoryID)).ToList();
                alarmHistory.ForEach(a =>
                {
                    historyDtos.RemoveAll(e => e.AlarmHistoryID == a.AlarmHistoryID);
                });
                if (historyDtos != null)
                {

                    await _alarmHistoryRepository.InsertAsync(AlarmHistoryDto.ToFuelDispenserList(historyDtos));
                }
            }
            catch (Exception ex)
            {

            }
        }
        public async Task RepeatOperation(int numberOfTimes)
        {
            for (int i = 0; i < numberOfTimes; i++)
            {
                // 在这里执行你想要重复的操作
                Console.WriteLine($"Executing operation {i + 1} of {numberOfTimes}");
                // 例如，你可以调用其他方法、发送请求、处理数据等等
            }
        }
        public async Task AddFuelDispenserAsync(Root myObject)
        {
            for (var i = 0; i < myObject.Content.Count(); i++)
            {
                await Dispensers(myObject.Content[i].Id);
                await GetLifecycleAsync(myObject.Content[i].Id);
                await GetAlarmHistoryAsync(myObject.Content[i].Id);
                DateTime? ProductTime = myObject.Content[i].ProductTime.HasValue
                    ? DateTimeOffset.FromUnixTimeMilliseconds(myObject.Content[i].ProductTime.Value).UtcDateTime
                    : (DateTime?)null;
                DateTime? StartTime = myObject.Content[i].StartTime.HasValue
                ? DateTimeOffset.FromUnixTimeMilliseconds(myObject.Content[i].StartTime.Value).UtcDateTime
                : (DateTime?)null;
                DateTime? InstallationDate = myObject.Content[i].FixTime.HasValue
               ? DateTimeOffset.FromUnixTimeMilliseconds(myObject.Content[i].FixTime.Value).UtcDateTime
               : (DateTime?)null;
                FuelDispenserDto fuelDispenserDto = new FuelDispenserDto
                {
                    Name = myObject.Content[i].Name,
                    OilCompany = myObject?.Content[i]?.Station?.Company?.Name,
                    GasStation = myObject.Content[i].Station?.Name,
                    SerialNumber = myObject.Content[i].SerialNum,
                    Model = myObject.Content[i].Type,
                    GunCount = myObject.Content[i].NozzleControlsTotal, // 例如，假设有4个枪
                    Manufacturer = myObject.Content[i].Supplier?.Name,//制造商
                    Description = myObject.Content[i].Supplier?.Description,//加油机厂商
                    ManufactureDate = ProductTime, // 使用实际的出厂时间
                    StartupDate = StartTime, // 使用实际的启动时间
                    InstallationDate = InstallationDate, // 使用实际的安装时间
                    DeviceStatus = myObject.Content[i].DeviceStatus,
                    OnlineStatus = myObject.Content[i].OnlineStatus,// 假设在线状态为1，可以根据实际情况设置
                    AccuracyLevel = myObject.Content[i].AccuracyLevel,//准确度等级
                    MeasureRang = myObject.Content[i].MeasureRang,//测量范围
                    ModelSpec = myObject.Content[i].ModelSpec,//规格参数
                    FuelId = myObject.Content[i].Id,
                    AlarmLevel = myObject.Content[i].AlarmLevel,
                    Province = myObject.Content[i].Station?.Province
                };
                var fuelDispenser = _fuelDispenserRepository.Where(x => x.SerialNumber == fuelDispenserDto.SerialNumber).First();
                if (fuelDispenser == null)
                {
                    await _fuelDispenserRepository.InsertAsync(fuelDispenserDto.ToFuelDispenser(fuelDispenserDto));
                }
                else
                {
                    fuelDispenser.DeviceStatus = fuelDispenserDto.DeviceStatus;
                    fuelDispenser.OnlineStatus = fuelDispenserDto.OnlineStatus;
                    fuelDispenser.FuelId = fuelDispenserDto.FuelId;
                    fuelDispenser.Province = myObject.Content[i].Station?.Province;
                    await _fuelDispenserRepository.UpdateAsync(fuelDispenser);
                }
            }
        }
        public async Task Dispensers(int FuelId)
        {
            HttpHelper helper = new HttpHelper();
            string result = await helper.GetDispensersDetailsAsync(string.Format(@"https://cma-fds.org.cn/api/v1/dispensers/{0}?", FuelId), token, FuelId);
            Rootobject myObject = Newtonsoft.Json.JsonConvert.DeserializeObject<Rootobject>(result);
            if (myObject != null)
            {
                string SerialNumber = myObject.serialNum;
                var fuelDispenser = _fuelDispenserRepository.Where(x => x.SerialNumber == SerialNumber).First();
                DateTime? fixTime = myObject.fixTime.HasValue
              ? DateTimeOffset.FromUnixTimeMilliseconds(myObject.fixTime.Value).UtcDateTime
              : (DateTime?)null;
                if (fuelDispenser != null)
                {
                    fuelDispenser.OnlineDesc = myObject.blackBoxesOnlineTime.onlineDesc;
                    fuelDispenser.InstallationDate = fixTime;
                    await _fuelDispenserRepository.UpdateAsync(fuelDispenser);
                }
                for (var i = 0; i < myObject.nozzleControls.Count(); i++)
                {
                    NozzlecontrolEntity nozzlecontrolEntity = new NozzlecontrolEntity();
                    nozzlecontrolEntity.Code = myObject.nozzleControls[i]?.code?.code;//编码
                    nozzlecontrolEntity.FuelName = myObject.nozzleControls[i].fuel?.fuelName;//油品
                    nozzlecontrolEntity.OnlineStatus = myObject.onlineStatus;//在线状态
                    nozzlecontrolEntity.Name = myObject.nozzleControls[i]?.name;//枪号
                    nozzlecontrolEntity.MainBoard = myObject.nozzleControls[i]?.taxControl?.mainBoard;
                    nozzlecontrolEntity.NozzleNo = myObject.nozzleControls[i]?.nozzleNo;
                    nozzlecontrolEntity.Alarming = myObject.alarming;
                    nozzlecontrolEntity.FuelId = FuelId;
                    await _nozzlecontrolRepository.InsertAsync(nozzlecontrolEntity);
                }
            }
        }
        /// <summary>
        /// 报警查询
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public async Task GetAlarmHistoryAsync()
        {
            string jsonString = File.ReadAllText("DataJson/报警查询.json");
            AlarmRootobject myObject = Newtonsoft.Json.JsonConvert.DeserializeObject<AlarmRootobject>(jsonString);

            try
            {

                HttpHelper helper = new HttpHelper();
                List<int> intList = new List<int>();
                List<AlarmHistoryDto> historyDtos = new List<AlarmHistoryDto>();
                for (var i = 0; i < myObject.data.content.Count(); i++)
                {
                    string origin = myObject.data.content[i].origin;
                    DateTime? CreatedDate = myObject.data.content[i].createdDate.HasValue
        ? DateTimeOffset.FromUnixTimeMilliseconds(myObject.data.content[i].createdDate.Value).UtcDateTime
        : (DateTime?)null;
                    AlarmHistoryDto alarmHistoryDto = new AlarmHistoryDto
                    {
                        FuelId = myObject.data.content[i].dispenser.id,
                        GasStation = myObject.data.content[i].station?.Name,
                        AlarmDescription = myObject.data.content[i].alarm?.description,
                        AlarmSource = origin == "blackBox" ? "安全装置" : origin == "platform" ? "云平台" : null,
                        SerialNumber = myObject.data.content[i].dispenser.serialNum,
                        AlarmType = myObject.data.content[i].alarm?.type,
                        CreatedDate = CreatedDate,
                        Name = myObject.data.content[i].dispenser.name,
                        AlarmHistoryID = myObject.data.content[i].id,
                        AlarmDeviceId = myObject.data.content[i].alarmDeviceId,
                        Description = myObject.data.content[i].description,
                        StationID = myObject.data.content[i].station?.Id,
                        CompanyID = myObject.data.content[i].company?.Id,
                        SupplierName = myObject.data.content[i].dispenser.supplier?.Name,
                        SupplierID = myObject.data.content[i].dispenser.supplier?.Id,
                        CompanyName = myObject.data.content[i].company?.Name,
                        AlarmLevel = myObject.data.content[i].dispenser.alarmLevel,
                    };
                    historyDtos.Add(alarmHistoryDto);
                    intList.Add(alarmHistoryDto.AlarmHistoryID);
                    GetPushRulesList(alarmHistoryDto);
                }
                var alarmHistory = _alarmHistoryRepository.Where(x => intList.Contains(x.AlarmHistoryID)).ToList();
                alarmHistory.ForEach(a =>
                {
                    historyDtos.RemoveAll(e => e.AlarmHistoryID == a.AlarmHistoryID);
                });
                if (historyDtos != null)
                {

                    await _alarmHistoryRepository.InsertAsync(AlarmHistoryDto.ToFuelDispenserList(historyDtos));
                }
            }
            catch (Exception ex)
            {

            }

        }
        /// <summary>
        /// 加油枪
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public async Task GetNozzleAsync()
        {
            string jsonString = File.ReadAllText("DataJson/加油枪.json");
            NozzleRootobject myObject = Newtonsoft.Json.JsonConvert.DeserializeObject<NozzleRootobject>(jsonString);

            try
            {

                HttpHelper helper = new HttpHelper();
                List<int> intList = new List<int>();
                List<NozzlecontrolEntity> historyDtos = new List<NozzlecontrolEntity>();
                for (var i = 0; i < myObject.data.content.Count(); i++)
                {
                    DateTime? startTime = myObject.data.content[i].startTime.HasValue
        ? DateTimeOffset.FromUnixTimeMilliseconds(myObject.data.content[i].startTime.Value).UtcDateTime
        : (DateTime?)null;
                    DateTime? FixTime = myObject.data.content[i].fixTime.HasValue
        ? DateTimeOffset.FromUnixTimeMilliseconds(myObject.data.content[i].fixTime.Value).UtcDateTime
        : (DateTime?)null;

                    NozzlecontrolEntity nozzle = new NozzlecontrolEntity
                    {
                        FuelId = myObject.data.content[i].dispenser.id,
                        FuelName = "",
                        Name = myObject.data.content[i].name,
                        NozzleNo = myObject.data.content[i].nozzleNo,
                        MainBoard = myObject.data.content[i].mainBoard,
                        OnlineStatus = myObject.data.content[i].onlineStatus,
                        TaxControlID = myObject.data.content[i].taxControl.id,
                        Hidden = myObject.data.content[i].hidden,
                        DeviceAlarmLevel = myObject.data.content[i].deviceAlarmLevel,
                        IotType = myObject.data.content[i].iotType,
                        ProductTime = startTime,
                        DeviceStatus = myObject.data.content[i].deviceStatus,
                        StartTime = startTime,
                        EncoderControlsID = i < myObject.data.content[i].encoderControls.Length ? myObject.data.content[i].encoderControls?[0]?.id : null,
                        AlarmLevel = myObject.data.content[i].alarmLevel,
                        Value = myObject.data.content[i].value,
                        DisplayControlsID = i < myObject.data.content[i].displayControls.Length ? myObject.data.content[i].displayControls?[0]?.id : null,
                        DisplayControlsNo = myObject.data.content[i].taxControl?.uuid,
                        Dirty = myObject.data.content[i].dirty,
                        Recover = myObject.data.content[i].recover,
                        FixTime = FixTime,
                        SoldTime = startTime,
                        CheatStatus = myObject.data.content[i].cheatStatus,
                        NozzleID = myObject.data.content[i].id

                    };
                    historyDtos.Add(nozzle);
                    intList.Add(nozzle.NozzleID);

                }
                var alarmHistory = _nozzlecontrolRepository.Where(x => intList.Contains(x.NozzleID)).ToList();
                alarmHistory.ForEach(a =>
                {
                    historyDtos.RemoveAll(e => e.NozzleID == a.NozzleID);
                });
                if (historyDtos != null)
                {

                    await _nozzlecontrolRepository.InsertAsync(historyDtos);
                }
            }
            catch (Exception ex)
            {

            }

        }
        /// <summary>
        /// 监控微处理器、编码器、加密显示屏
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public async Task GetEquipmentAsync(string token, string DeviceType)
        {
            int currentPage = 0;
            int pageSize = 20;
            try
            {
                HttpHelper helper = new HttpHelper();
                while (true)
                {
                    string result = await helper.GetTaxcontrolsAsync(string.Format(@"https://cma-fds.org.cn/api/v1/taxcontrols"), token, pageSize, currentPage);
                    //Rootobject myObject = Newtonsoft.Json.JsonConvert.DeserializeObject<Rootobject>(result);
                    //string jsonString = File.ReadAllText("DataJson/监控微处理器.json");
                    EquipmentRootobject myObject = Newtonsoft.Json.JsonConvert.DeserializeObject<EquipmentRootobject>(result);
                    List<int> intList = new List<int>();
                    List<EquipmentEntity> historyDtos = new List<EquipmentEntity>();
                    if (myObject == null || myObject.data == null || myObject.data.content.Count() == 0)
                    {
                        break;
                    }
                    for (var i = 0; i < myObject.data.content.Count(); i++)
                    {
                        DateTime? FixTime = myObject.data.content[i].fixTime.HasValue
            ? DateTimeOffset.FromUnixTimeMilliseconds(myObject.data.content[i].fixTime.Value).UtcDateTime
            : (DateTime?)null;

                        EquipmentEntity nozzle = new EquipmentEntity
                        {
                            DeviceType = DeviceType,
                            mainBoard = myObject.data.content[i].mainBoard,
                            DeviceAlarmLevel = myObject.data.content[i].deviceAlarmLevel,
                            OnlineStatus = myObject.data.content[i].onlineStatus,
                            Uuid = myObject.data.content[i].uuid,
                            DeviceStatus = myObject.data.content[i].deviceStatus,
                            SupplierID = myObject.data.content[i].supplier?.id,
                            Id = myObject.data.content[i].id,
                            DispenserSupplierId = myObject.data.content[i].dispenserSupplierId,
                            Dirty = myObject.data.content[i].dirty,
                            NozzleControlName = myObject.data.content[i].nozzleControlName,
                            BlackBoxID = myObject.data.content[i].blackBox?.id,
                            FixTime = FixTime
                        };
                        historyDtos.Add(nozzle);
                        intList.Add(nozzle.Id);

                    }
                    // 增加当前页数
                    currentPage++;
                    var alarmHistory = _equipmentRepository.Where(x => intList.Contains(x.Id)).ToList();
                    alarmHistory.ForEach(a =>
                    {
                        historyDtos.RemoveAll(e => e.Id == a.Id);
                    });
                    if (historyDtos != null)
                    {

                        await _equipmentRepository.InsertAsync(historyDtos);
                    }
                }
            }
            catch (Exception ex)
            {

            }

        }
        /// <summary>
        /// 用户管理
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public async Task GetAssociationUserAsync(string token, string url)
        {
            //EquipmentRootobject myObject = Newtonsoft.Json.JsonConvert.DeserializeObject<EquipmentRootobject>(result);

            //string jsonString = File.ReadAllText("DataJson/用户管理.json");
            int currentPage = 0;
            int pageSize = 20;
            try
            {

                HttpHelper helper = new HttpHelper();
                string result = await helper.GetTaxcontrolsAsync(string.Format(url), token, pageSize, currentPage);

                //EquipmentRootobject myObject = Newtonsoft.Json.JsonConvert.DeserializeObject<EquipmentRootobject>(result);

                //string jsonString = File.ReadAllText("DataJson/用户管理.json");
                UserRootobject myObject = Newtonsoft.Json.JsonConvert.DeserializeObject<UserRootobject>(result);
                List<int> intList = new List<int>();
                List<AssociationUserEntity> historyDtos = new List<AssociationUserEntity>();
                for (var i = 0; i < myObject.data.content.Count(); i++)
                {
                    DateTime? UpdatePasswordTime = myObject.data.content[i].updatePasswordTime.HasValue
        ? DateTimeOffset.FromUnixTimeMilliseconds(myObject.data.content[i].updatePasswordTime.Value).UtcDateTime
        : (DateTime?)null;

                    AssociationUserEntity nozzle = new AssociationUserEntity
                    {
                        Admin = myObject.data.content[i].admin,
                        IsLock = myObject.data.content[i].isLock,
                        UpdatePasswordTime = UpdatePasswordTime,
                        ModifyPass = myObject.data.content[i].modifyPass,
                        Id = myObject.data.content[i].id,
                        Email = myObject.data.content[i].email,
                        IdentityName = myObject.data.content[i].identityName,
                        Mobile = myObject.data.content[i].mobile,
                        IdentityId = myObject.data.content[i].identityId,
                        Disable = myObject.data.content[i].disable,
                        Name = myObject.data.content[i].name,
                        Age = myObject.data.content[i].age
                    };
                    historyDtos.Add(nozzle);
                    intList.Add(nozzle.Id);

                }
                var alarmHistory = _associationUserRepository.Where(x => intList.Contains(x.Id)).ToList();
                alarmHistory.ForEach(a =>
                {
                    historyDtos.RemoveAll(e => e.Id == a.Id);
                });
                if (historyDtos != null)
                {

                    await _associationUserRepository.InsertAsync(historyDtos);
                }
            }
            catch (Exception ex)
            {

            }

        }


        /// <summary>
        /// 油站管理
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public async Task GetStationAsync(string token, string url)
        {
            //string jsonString = File.ReadAllText("DataJson/油站.json");
            //StationRootobject myObject = Newtonsoft.Json.JsonConvert.DeserializeObject<StationRootobject>(jsonString);
            int currentPage = 0;
            int pageSize = 20;
            try
            {

                HttpHelper helper = new HttpHelper();
                string result = await helper.GetTaxcontrolsAsync(string.Format(url), token, pageSize, currentPage);
                StationRootobject myObject = Newtonsoft.Json.JsonConvert.DeserializeObject<StationRootobject>(result);
                List<int> intList = new List<int>();
                List<StationEntity> historyDtos = new List<StationEntity>();
                for (var i = 0; i < myObject.data.content.Count(); i++)
                {
                    DateTime? AlarmTime = DateTimeOffset.FromUnixTimeMilliseconds(myObject.data.content[i].alarmTime).UtcDateTime;

                    StationEntity nozzle = new StationEntity
                    {
                        Alarming = myObject.data.content[i].alarming,
                        DistrictCode = myObject.data.content[i].districtCode,
                        City = myObject.data.content[i].city,
                        CityCode = myObject.data.content[i].cityCode,
                        Type = myObject.data.content[i].type,
                        RegisterNo = "",
                        Province = myObject.data.content[i].province,
                        Contact = myObject.data.content[i].contact,
                        Lat = myObject.data.content[i].lat,
                        Address = myObject.data.content[i].address,
                        Lng = myObject.data.content[i].lng,
                        Test = myObject.data.content[i].test,
                        Business = myObject.data.content[i].alarming,
                        ProvinceCode = myObject.data.content[i].provinceCode,
                        AlarmTime = AlarmTime,
                        DispensersTotal = myObject.data.content[i].dispensersTotal,
                        Phone = myObject.data.content[i].phone,
                        District = myObject.data.content[i].district,
                        Name = myObject.data.content[i].name,
                        NoticesTotal = myObject.data.content[i].noticesTotal,
                        NozzleControlsTotal = myObject.data.content[i].nozzleControlsTotal,
                        CompanyID = myObject.data.content[i].id,
                    };
                    historyDtos.Add(nozzle);
                    intList.Add(nozzle.CompanyID);

                }
                var alarmHistory = _stationRepository.Where(x => intList.Contains(x.CompanyID)).ToList();
                alarmHistory.ForEach(a =>
                {
                    historyDtos.RemoveAll(e => e.Id == a.Id);
                });
                if (historyDtos != null)
                {

                    await _stationRepository.InsertAsync(historyDtos);
                }
            }
            catch (Exception ex)
            {

            }

        }


        /// <summary>
        /// 规则匹配
        /// </summary>
        /// <param name="alarmHistoryEntity"></param>
        /// <returns></returns>
        public List<PushRuleEntity> GetPushRulesList(AlarmHistoryDto alarmHistoryEntity)
        {
            var list = _pushRuleRepository.Where(_ => _.IsActive).OrderBy(_ => _.TaskPriority).ToList();
            var users = _userRepository.Select.ToList();
            var userrole = _userPoleRepository.Select.ToList();
            var rolemapping = _roleMappingRepository.Select.ToList();
            bool Conditions = false;
            List<PushEntity> pushlist = new List<PushEntity>();
            foreach (var pushRule in list)
            {
                List<pushruleDto> pushruleDto = JsonSerializer.Deserialize<List<pushruleDto>>(pushRule.ConditionsJson);
                foreach (var trigger in pushruleDto)
                {
                    if (pushRule.TriggerMethod == "0")//满足一条
                    {
                        Conditions = AlarmRule(trigger, alarmHistoryEntity);
                    }
                    else if (pushRule.TriggerMethod == "1")//全部满足
                    {
                        Conditions = AllAlarmRule(trigger, alarmHistoryEntity);
                        if (!Conditions)
                        {
                            continue;
                        }
                    }
                }
                if (Conditions)
                {
                    Regex regex = new Regex(pushRule.Regular);//正则
                    Match match = regex.Match(alarmHistoryEntity.AlarmDescription);
                    if (match.Success)
                    {
                        var role = rolemapping.Where(_ => _.RoleMappingId == pushRule.RoleMappingId).Select(_ => _.RoleID).ToList();
                        if (role != null)
                        {
                            var urole = userrole.Where(_ => role.Contains(_.RoleId)).ToList();
                            foreach (var u in urole)
                            {
                                var user = users.Where(_ => _.Id == u.UserId).First();
                                PushEntity pushEntity = new PushEntity();
                                pushEntity.RuleId = pushRule.Id;
                                pushEntity.PushUserid = u.UserId;
                                pushEntity.Content = alarmHistoryEntity.AlarmDescription;
                                pushEntity.AlarmhistoryID = alarmHistoryEntity.AlarmHistoryID;
                                pushEntity.TaskPriority = pushRule.TaskPriority;
                                pushlist.Add(pushEntity);
                            }
                        }
                        //插入推送表
                    }
                }
            }
            if (pushlist.Count > 0)
            {
                _pushRepository.Insert(pushlist);
            }
            List<PushRuleEntity> pushRules = new List<PushRuleEntity>();
            return pushRules;
        }
        public bool AllAlarmRule(pushruleDto trigger, AlarmHistoryDto alarmHistoryEntity)
        {
            bool Conditions = false;
            string Left = trigger.Left;
            string inthe = trigger.inthe;
            int? Right = 0;
            string Symbol = trigger.Symbol;
            if (int.TryParse(trigger.Right, out int result))
            {
                Right = result;
            }
            if (Left == "报警设备")
            {
                if (alarmHistoryEntity.AlarmDevice == trigger.inthe)
                {
                    Conditions = true;
                }
                if (!Conditions)
                {
                    return false;
                }
                Conditions = CompareStringToInt(trigger.Symbol, trigger.Right, alarmHistoryEntity.AlarmLevel);
                if (!Conditions)
                {
                    return false;
                }
            }
            else if (Left == "报警类型")
            {
                if (alarmHistoryEntity.AlarmType == trigger.inthe)
                {
                    Conditions = true;
                }
                if (!Conditions)
                {
                    return false;
                }
                Conditions = CompareStringToInt(trigger.Symbol, trigger.Right, alarmHistoryEntity.AlarmLevel);
                if (!Conditions)
                {
                    return false;
                }
            }
            else if (Left == "报警来源")
            {
                if (alarmHistoryEntity.AlarmSource == trigger.inthe)
                {
                    Conditions = true;
                }
                if (!Conditions)
                {
                    return false;
                }
                Conditions = CompareStringToInt(trigger.Symbol, trigger.Right, alarmHistoryEntity.AlarmLevel);
                if (!Conditions)
                {
                    return false;
                }
            }
            return Conditions;
        }
        /// <summary>
        /// 满足一次触发
        /// </summary>
        /// <param name="trigger"></param>
        /// <param name="alarmHistoryEntity"></param>
        /// <returns></returns>
        public bool AlarmRule(pushruleDto trigger, AlarmHistoryDto alarmHistoryEntity)
        {
            bool Conditions = false;
            string Left = trigger.Left;
            string inthe = trigger.inthe;
            int? Right = 0;
            string Symbol = trigger.Symbol;
            if (int.TryParse(trigger.Right, out int result))
            {
                Right = result;
            }
            if (Left == "报警设备")
            {
                if (alarmHistoryEntity.AlarmDevice == trigger.inthe)
                {
                    Conditions = true;
                }
                Conditions = CompareStringToInt(trigger.Symbol, trigger.Right, alarmHistoryEntity.AlarmLevel);
                if (Conditions)
                {
                    return true;
                }
            }
            else if (Left == "报警类型")
            {
                if (alarmHistoryEntity.AlarmType == trigger.inthe)
                {
                    Conditions = true;
                }
                Conditions = CompareStringToInt(trigger.Symbol, trigger.Right, alarmHistoryEntity.AlarmLevel);
                if (Conditions)
                {
                    return true;
                }
            }
            else if (Left == "报警来源")
            {
                if (alarmHistoryEntity.AlarmSource == trigger.inthe)
                {
                    Conditions = true;
                }
                Conditions = CompareStringToInt(trigger.Symbol, trigger.Right, alarmHistoryEntity.AlarmLevel);
                if (Conditions)
                {
                    return true;
                }
            }
            return Conditions;
        }
        /// <summary>
        /// 判断大于等于小于
        /// </summary>
        /// <param name="Symbol"></param>
        /// <param name="Right"></param>
        /// <returns></returns>
        public bool CompareStringToInt(string Symbol, string Right, int? AlarmLevel)
        {
            int? level = 0;
            if (int.TryParse(Right, out int result))
            {
                level = result;
            }
            if (Symbol == "<")
            {
                if (AlarmLevel < level)
                {
                    return true;
                }
            }
            else if (Symbol == "=")
            {
                if (AlarmLevel == level)
                {
                    return true;
                }
            }
            else if (Symbol == ">")
            {
                if (AlarmLevel > level)
                {
                    return true;
                }
            }
            return false;
        }
        /// <summary>
        /// 通过id获取站点信息
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        [HttpGet]
        public async Task GetStationList()
        {
            HttpHelper helper = new HttpHelper();
            int currentPage = 0;
            int pageSize = 20;
            try
            {
                while (true)
                {
                    string url = "https://cma-fds.org.cn/api/open/v1/station/list?page=" + currentPage + "&size=" + pageSize + "&expand=supervision&expand=company";
                    string secureRandomString = GenerateSecureRandomString(10);//生成10位随机字符串
                    string unixTimestampMs = ((DateTimeOffset)DateTime.UtcNow).ToUnixTimeMilliseconds().ToString();//生成时间戳，精确到毫秒
                    var query = "query={\"page\":\"" + currentPage + "\",\"size\":\"" + pageSize + "\",\"expand\":[\"supervision\",\"company\"]}";
                    string stringToSign = $"sign_method=HMAC-SM3&secret_id=AwTHQMpzVvsCe7qx&nonce={secureRandomString}&timestamp={unixTimestampMs}";
                    stringToSign = stringToSign + "&" + query;
                    var encodedString = Uri.EscapeDataString(stringToSign);
                    byte[] hmac = HMAC_SM3.ComputeHash("BK6gfhrUxxtIqD7ZeTU0LTd1w9SOseih", encodedString, System.Text.Encoding.UTF8);
                    var signature = Convert.ToBase64String(hmac);
                    string result = await helper.GetAsync(string.Format(url), secureRandomString, unixTimestampMs, signature);
                    StationRootobject myObject = Newtonsoft.Json.JsonConvert.DeserializeObject<StationRootobject>(result);
                    if (myObject == null || myObject.data == null || myObject.data.content.Count() == 0)
                    {
                        break;
                    }
                    List<StationEntity> list = new List<StationEntity>();
                    List<int> intList = new List<int>();
                    for (var i = 0; i < myObject.data.content.Count(); i++)
                    {
                        DateTime? AlarmTime = DateTimeOffset.FromUnixTimeMilliseconds(myObject.data.content[i].alarmTime).UtcDateTime;

                        StationEntity nozzle = new StationEntity
                        {
                            Alarming = myObject.data.content[i].alarming,
                            DistrictCode = myObject.data.content[i].districtCode,
                            City = myObject.data.content[i].city,
                            CityCode = myObject.data.content[i].cityCode,
                            Type = myObject.data.content[i].type,
                            RegisterNo = "",
                            Province = myObject.data.content[i].province,
                            Contact = myObject.data.content[i].contact,
                            Lat = myObject.data.content[i].lat,
                            Address = myObject.data.content[i].address,
                            Lng = myObject.data.content[i].lng,
                            Test = myObject.data.content[i].test,
                            Business = myObject.data.content[i].alarming,
                            ProvinceCode = myObject.data.content[i].provinceCode,
                            AlarmTime = AlarmTime,
                            DispensersTotal = myObject.data.content[i].dispensersTotal,
                            Phone = myObject.data.content[i].phone,
                            District = myObject.data.content[i].district,
                            Name = myObject.data.content[i].name,
                            NoticesTotal = myObject.data.content[i].noticesTotal,
                            NozzleControlsTotal = myObject.data.content[i].nozzleControlsTotal,
                            CompanyID = myObject.data.content[i].company.id,
                            StationID = myObject.data.content[i].id,
                            supervision = myObject.data.content[i].supervision.id
                        };
                        list.Add(nozzle);
                        intList.Add(nozzle.CompanyID);
                    }
                    currentPage++;  // 增加当前页数
                    var _station = _stationRepository.Where(x => intList.Contains(x.CompanyID)).ToList();
                    _station.ForEach(a =>
                    {
                        list.RemoveAll(e => e.Id == a.Id);
                    });
                    if (list != null)
                    {

                        await _stationRepository.InsertAsync(list);
                    }
                }
            }
            catch (Exception ex)
            {

            }
        }

        public async Task<string> GetAsync(string url, string query)
        {
            HttpHelper helper = new HttpHelper();
            string secureRandomString = GenerateSecureRandomString(10);//生成10位随机字符串
            string unixTimestampMs = ((DateTimeOffset)DateTime.UtcNow).ToUnixTimeMilliseconds().ToString();//生成时间戳，精确到毫秒
            string stringToSign = $"sign_method=HMAC-SM3&secret_id=AwTHQMpzVvsCe7qx&nonce={secureRandomString}&timestamp={unixTimestampMs}";
            stringToSign = stringToSign + "&" + query;
            var encodedString = Uri.EscapeDataString(stringToSign);
            byte[] hmac = HMAC_SM3.ComputeHash("BK6gfhrUxxtIqD7ZeTU0LTd1w9SOseih", encodedString, System.Text.Encoding.UTF8);
            var signature = Convert.ToBase64String(hmac);
            string result = await helper.GetAsync(string.Format(url), secureRandomString, unixTimestampMs, signature);
            return result;
        }
        /// <summary>
        /// 获取油机列表
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        [HttpGet]
        public async Task GetDispenserList()
        {
            HttpHelper helper = new HttpHelper();
            int currentPage = 7;
            int pageSize = 20;
            try
            {
                while (true)
                {
                    string url = "https://cma-fds.org.cn/api/open/v1/dispenser/list?page=" + currentPage + "&size=" + pageSize + "&expand=supplier&expand=station&expand=nozzleControls&expand=nozzleControls.fuel&expand=vaporRecoveryControl&expand=calculatorMainboard";
                    var query = "query={\"page\":\"" + currentPage + "\",\"size\":\"" + pageSize + "\",\"expand\":[\"supplier\",\"station\",\"nozzleControls\",\"nozzleControls.fuel\",\"vaporRecoveryControl\",\"calculatorMainboard\"]}";
                    string result = await GetAsync(url, query);
                    DispenserDto myObject = Newtonsoft.Json.JsonConvert.DeserializeObject<DispenserDto>(result);
                    if (myObject == null || myObject.data == null || myObject.data.content.Count() == 0)
                    {
                        break;
                    }
                    List<StationEntity> list = new List<StationEntity>();
                    List<int> intList = new List<int>();
                    for (var i = 0; i < myObject.data.content.Count(); i++)
                    {

                        DateTime? ProductTime = DateTimeOffset.FromUnixTimeMilliseconds(myObject.data.content[i].productTime).UtcDateTime;
                        DateTime? StartTime = DateTimeOffset.FromUnixTimeMilliseconds(myObject.data.content[i].startTime).UtcDateTime;
                        DateTime? InstallationDate = DateTimeOffset.FromUnixTimeMilliseconds(myObject.data.content[i].fixTime).UtcDateTime;
                        FuelDispenserDto fuelDispenserDto = new FuelDispenserDto
                        {
                            Name = myObject.data.content[i].name,
                            OilCompany = myObject?.data.content[i]?.station?.Company?.Name,
                            GasStation = myObject.data.content[i].station?.Name,
                            SerialNumber = myObject.data.content[i].serialNum,
                            Model = myObject.data.content[i].type,
                            GunCount = myObject.data.content[i].nozzleControlsTotal, // 例如，假设有4个枪
                            Manufacturer = myObject.data.content[i].supplier?.Name,//制造商
                            Description = myObject.data.content[i].supplier?.Description,//加油机厂商
                            ManufactureDate = ProductTime, // 使用实际的出厂时间
                            StartupDate = StartTime, // 使用实际的启动时间
                            InstallationDate = InstallationDate, // 使用实际的安装时间
                            DeviceStatus = myObject.data.content[i].deviceStatus,
                            OnlineStatus = myObject.data.content[i].onlineStatus,// 假设在线状态为1，可以根据实际情况设置
                            AccuracyLevel = myObject.data.content[i].accuracyLevel,//准确度等级
                            MeasureRang = myObject.data.content[i].measureRang,//测量范围
                            ModelSpec = myObject.data.content[i].modelSpec,//规格参数
                            FuelId = myObject.data.content[i].id,
                            AlarmLevel = myObject.data.content[i].alarmLevel,
                            Province = myObject.data.content[i].station?.Province,
                            Phone = "",
                            Contact = "",
                            SealNo = myObject.data.content[i].serialNum,
                            photoIds = "",
                            VerificationCode = ""
                        };
                        await AddNozzle(myObject.data.content[i].nozzleControls, myObject.data.content[i].id, myObject.data.content[i].station);
                        var fuelDispenser = _fuelDispenserRepository.Where(x => x.FuelId == fuelDispenserDto.FuelId).First();
                        if (fuelDispenser == null)
                        {
                            await _fuelDispenserRepository.InsertAsync(fuelDispenserDto.ToFuelDispenser(fuelDispenserDto));
                        }
                        else
                        {
                            fuelDispenser.DeviceStatus = fuelDispenserDto.DeviceStatus;
                            fuelDispenser.OnlineStatus = fuelDispenserDto.OnlineStatus;
                            fuelDispenser.FuelId = fuelDispenserDto.FuelId;
                            fuelDispenser.Province = myObject.data.content[i].station?.Province;
                            await _fuelDispenserRepository.UpdateAsync(fuelDispenser);
                        }
                    }
                    currentPage++;  // 增加当前页数

                }
            }
            catch (Exception ex)
            {

            }
        }

        /// <summary>
        /// 添加油枪
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public async Task AddNozzle(DispenserNozzlecontrol[] nozzlecontrols, int FuelId, Station station)
        {
            try
            {
                List<NozzlecontrolEntity> nozzle = new List<NozzlecontrolEntity>();
                foreach (var nozzlecontrol in nozzlecontrols)
                {
                    DateTime? ProductTime = DateTimeOffset.FromUnixTimeMilliseconds(nozzlecontrol.productTime).UtcDateTime;
                    DateTime? StartTime = DateTimeOffset.FromUnixTimeMilliseconds(nozzlecontrol.startTime).UtcDateTime;
                    DateTime? FixTime = DateTimeOffset.FromUnixTimeMilliseconds(nozzlecontrol.fixTime).UtcDateTime;
                    DateTime? SoldTime = DateTimeOffset.FromUnixTimeMilliseconds(nozzlecontrol.soldTime).UtcDateTime;
                    DateTime? CreatedDate = DateTimeOffset.FromUnixTimeMilliseconds(nozzlecontrol.createdDate).UtcDateTime;
                    var nozzleinfo = await GetNozzleInfo(nozzlecontrol.id, FuelId, station?.Id, nozzlecontrol.fuel?.fuelName);
                    nozzle.Add(new NozzlecontrolEntity()
                    {
                        NozzleID = nozzlecontrol.id,
                        FuelId = FuelId,
                        FuelName = nozzlecontrol.fuel?.fuelName,
                        Name = nozzlecontrol.name,
                        MainBoard = nozzlecontrol.mainBoard,
                        NozzleNo = nozzlecontrol.nozzleNo,
                        OnlineStatus = nozzlecontrol.onlineStatus,
                        Hidden = nozzlecontrol.hidden,
                        DeviceAlarmLevel = nozzlecontrol.deviceAlarmLevel,
                        IotType = nozzlecontrol.iotType,
                        ProductTime = ProductTime,
                        DeviceStatus = nozzlecontrol.deviceStatus,
                        StartTime = StartTime,
                        AlarmLevel = nozzlecontrol.alarmLevel,
                        Value = nozzlecontrol.value,
                        Dirty = nozzlecontrol.dirty,
                        Recover = nozzlecontrol.recover,
                        FixTime = FixTime,
                        CreatedDate = CreatedDate,
                        CreatedBy = nozzlecontrol.createdBy,
                        CheatStatus = nozzlecontrol.cheatStatus,
                        GasStation = station?.Name,//加油站
                        SupplierName = "",//供应商名称
                        CompanyName = "",//公司名称
                        StationID = station?.Id,

                    });
                }
                await _nozzlecontrolRepository.InsertAsync(nozzle);
            }
            catch (Exception ex)
            {

            }
        }
        /// <summary>
        /// 根据id获取油枪信息
        /// </summary>
        /// <param name="id"></param>
        /// <param name="FuelId"></param>
        /// <param name="stationid"></param>
        /// <param name="fuelName"></param>
        /// <returns></returns>
        public async Task<NozzleDetails> GetNozzleInfo(int id, int FuelId, int? stationid,string fuelName)
        {
            HttpHelper helper = new HttpHelper();
            string url = "https://cma-fds.org.cn/api/open/v1/nozz/getNozzById?id=" + id + "&expand=supplier&expand=blackBox&expand=encoderControls&expand=meters&expand=vaporRecoveryControl&expand=taxControl&expand=displayControls&expand=valveControls&expand=station";
            var query = "query={\"id\":\"" + id + "\",\"expand\":[\"supplier\",\"blackBox\",\"encoderControls\",\"meters\",\"vaporRecoveryControl\",\"taxControl\",\"displayControls\",\"valveControls\",\"station\"]}";
            string result = await GetAsync(url, query);
            NozzleDetails myObject = Newtonsoft.Json.JsonConvert.DeserializeObject<NozzleDetails>(result);

            //安全监督装置
            if (myObject.data.blackBox != null)
            {
                AddBlackBox(myObject.data.blackBox, FuelId, stationid);
            }

            //编码器
            if (myObject.data.encoderControls != null && myObject.data.encoderControls.Count() > 0)
            {
                AddEncoderControls(myObject.data.encoderControls, FuelId, stationid, myObject.data.blackBox?.id);
            }

            //计量器
            if (myObject.data.meters != null && myObject.data.meters.Count() > 0)
            {
                AddMeters(myObject.data.meters, FuelId, stationid);
            }

            //油气回收控制板
            if (myObject.data.vaporRecoveryControl != null)
            {
                AddVaporRecoveryControl(myObject.data.vaporRecoveryControl, FuelId, stationid, myObject.data.blackBox?.id);
            }

            //监控微处理器
            if (myObject.data.taxControl != null)
            {
                AddTaxControl(myObject.data.taxControl, FuelId, stationid, myObject.data.blackBox?.id, myObject.data.name, fuelName);
            }

            //显示屏
            if (myObject.data.displayControls != null && myObject.data.displayControls.Count() > 0)
            {
                AddDisplayControls(myObject.data.displayControls, FuelId, stationid, myObject.data.blackBox?.id, myObject.data.name, fuelName);
            }

            //智能型控制阀
            if (myObject.data.valveControls != null && myObject.data.valveControls.Count() > 0)
            {

            }

            return myObject;
        }
        /// <summary>
        /// 添加显示屏
        /// </summary>
        /// <param name="NozzleDetailsTaxcontrol"></param>
        /// <param name="fuelId"></param>
        /// <param name="stationId"></param>
        /// <returns></returns>
        public async Task AddDisplayControls(NozzleDisplaycontrol[] displaycontrols, int fuelId, int? stationId, int? blackBoxID, string NozzleName, string fuelName)
        {
            List<DisplayControlEntity> list = new List<DisplayControlEntity>();
            foreach (var control in displaycontrols)
            {
                DateTime? modifiedDate = DateTimeOffset.FromUnixTimeMilliseconds(control.modifiedDate).UtcDateTime;
                DateTime? fixTime = DateTimeOffset.FromUnixTimeMilliseconds(control.fixTime).UtcDateTime;
                DateTime? createdDate = DateTimeOffset.FromUnixTimeMilliseconds(control.createdDate).UtcDateTime;
                DateTime? startTime = DateTimeOffset.FromUnixTimeMilliseconds(control.startTime).UtcDateTime;
                DisplayControlEntity entity = new DisplayControlEntity
                {
                    Uuid = control.uuid,
                    Sn = control.sn,
                    DispenserSupplierId = control.dispenserSupplierId,  
                    Dirty = control.dirty,
                    BlackBoxID = blackBoxID,
                    StationID = stationId,
                    SupplierID = null,
                    OnlineStatus = control.onlineStatus,
                    DeviceStatus = control.deviceStatus,
                    DeviceAlarmLevel = control.deviceAlarmLevel,
                    ProductTime = null,
                    SoldTime = null,
                    StartTime = startTime,
                    FixTime = fixTime,
                    PhotoId = control.photoId,                          
                    Alarms = JsonSerializer.Serialize(control.alarms),
                    LawSwv =null,
                    LawSwi = null
                };

                list.Add(entity);
            }
            await _displayControlRepository.InsertAsync(list);
        }
        /// <summary>
        /// 添加监控微处理器
        /// </summary>
        /// <param name="NozzleDetailsTaxcontrol"></param>
        /// <param name="fuelId"></param>
        /// <param name="stationId"></param>
        /// <returns></returns>
        public async Task AddTaxControl(NozzleDetailsTaxcontrol taxControl, int fuelId, int? stationId, int? blackBoxID,string NozzleName, string fuelName)
        {
            DateTime? modifiedDate = DateTimeOffset.FromUnixTimeMilliseconds(taxControl.modifiedDate).UtcDateTime;
            DateTime? productTime = DateTimeOffset.FromUnixTimeMilliseconds(taxControl.productTime).UtcDateTime;
            DateTime? fixTime = DateTimeOffset.FromUnixTimeMilliseconds(taxControl.fixTime).UtcDateTime;
            DateTime? soldTime = DateTimeOffset.FromUnixTimeMilliseconds(taxControl.soldTime).UtcDateTime;
            DateTime? createdDate = DateTimeOffset.FromUnixTimeMilliseconds(taxControl.createdDate).UtcDateTime;
            DateTime? startTime = DateTimeOffset.FromUnixTimeMilliseconds(taxControl.startTime).UtcDateTime;
            TaxControlEntity entity = new TaxControlEntity
            {
                // 按类定义逐项赋值
                MainBoard = taxControl.mainBoard,
                ResetTimes = taxControl.resetTimes,
                DeviceAlarmLevel = taxControl.deviceAlarmLevel,
                OnlineStatus = taxControl.onlineStatus,
                Uuid = taxControl.uuid,
                SignVerify = taxControl.signVerify,
                DeviceStatus = taxControl.deviceStatus,
                ModifiedBy = taxControl.modifiedBy,
                AlarmLevel = taxControl.alarmLevel,
                Id = taxControl.id,
                DispenserSupplierId = taxControl.dispenserSupplierId,
                Dirty = taxControl.dirty,
                Alarms = JsonSerializer.Serialize(taxControl.alarms),
                NozzleControlName = taxControl.nozzleControlName,
                FixTime = fixTime,
                CreatedDate = taxControl.createdDate,     
                CreatedBy = taxControl.createdBy,
                ModifiedDate = taxControl.modifiedDate,     
                FuelID = fuelId,                    
                Name = NozzleName,
                NozzleNo = null,
                CheatStatus = null,
                Recover = null,
                Value = null,
                Hidden = null,
                TaxAlarms = null,
                IotType = null,
                BlackBoxID = blackBoxID,
                StationID = stationId,
                FuelName = fuelName,
                Code = null,
                ProductTime = productTime,
                SoldTime = soldTime,
                StartTime = startTime
            };
            await _taxControlRepository.InsertAsync(entity);
        }
        /// <summary>
        /// 添加油气回收控制板
        /// </summary>
        /// <param name="vaporrecoverycontrol"></param>
        /// <param name="fuelId"></param>
        /// <param name="stationId"></param>
        /// <returns></returns>
        public async Task AddVaporRecoveryControl(Vaporrecoverycontrol control, int fuelId, int? stationId,int? blackBoxID)
        {
            DateTime? modifiedDate = DateTimeOffset.FromUnixTimeMilliseconds(control.modifiedDate).UtcDateTime;
            DateTime? productTime = DateTimeOffset.FromUnixTimeMilliseconds(control.productTime).UtcDateTime;
            DateTime? fixTime = DateTimeOffset.FromUnixTimeMilliseconds(control.fixTime).UtcDateTime;
            DateTime? soldTime = DateTimeOffset.FromUnixTimeMilliseconds(control.soldTime).UtcDateTime;
            DateTime? createdDate = DateTimeOffset.FromUnixTimeMilliseconds(control.createdDate).UtcDateTime;
            DateTime? startTime = DateTimeOffset.FromUnixTimeMilliseconds(control.startTime).UtcDateTime;
            VaporRecoveryControlEntity entity = new VaporRecoveryControlEntity
            {
                // 按类定义逐项赋值
                Uuid = control.uuid,
                Swv = null,
                Hdv = null,
                SecCpuUuid = null,
                DispenserSupplierId = control.dispenserSupplierId,  
                Dirty = control.dirty,
                Signature = control.signature,
                SignVerify = control.signVerify,
                VaporRecoverySoftware = null,
                BlackBoxID = blackBoxID,                    
                StationID = stationId,
                SupplierID = null,                  
                OnlineStatus = control.onlineStatus,
                DeviceStatus = control.deviceStatus,
                DeviceAlarmLevel = control.deviceAlarmLevel,
                ProductTime = productTime,
                SoldTime = soldTime,
                StartTime = startTime,
                FixTime = fixTime,
                PhotoId = control.photoId,                       
                Alarms = JsonSerializer.Serialize(control.alarms),
                LawSwv = null,
                LawSwi = null
            };
            await _vaporRecoveryControlRepository.InsertAsync(entity);

        }
        /// <summary>
        /// 添加计量器
        /// </summary>
        /// <param name="nozzleEncodercontrols"></param>
        /// <param name="fuelId"></param>
        /// <param name="stationId"></param>
        /// <param name="blackBoxid"></param>
        /// <returns></returns>
        public async Task AddMeters(NozzleMeter[] nozzleMeters, int fuelId, int? stationId)
        { 
            List<MeterEntity> list = new List<MeterEntity>();
            foreach (var meter in nozzleMeters)
            {
                DateTime? modifiedDate = DateTimeOffset.FromUnixTimeMilliseconds(meter.modifiedDate).UtcDateTime;
                DateTime? fixTime = DateTimeOffset.FromUnixTimeMilliseconds(meter.fixTime).UtcDateTime;
                DateTime? createdDate = DateTimeOffset.FromUnixTimeMilliseconds(meter.createdDate).UtcDateTime;
                DateTime? startTime = DateTimeOffset.FromUnixTimeMilliseconds(meter.startTime).UtcDateTime;
                MeterEntity entity = new MeterEntity
                {
                 
                    Uuid = meter.uuid,
                    StationID = stationId,         
                    SupplierID = null,
                    OnlineStatus = meter.onlineStatus,
                    DeviceStatus = meter.deviceStatus,
                    DeviceAlarmLevel = meter.deviceAlarmLevel,
                    ProductTime = null,
                    SoldTime = null,
                    StartTime = startTime,
                    PhotoId = meter.photoId,            
                    FixTime = fixTime,
                    Alarms = JsonSerializer.Serialize(meter.alarms),
                    id = meter.id,
                    FuelId = fuelId,
                };
                list.Add(entity);
            }
            await _meterRepository.InsertAsync(list);
        }
        /// <summary>
        /// 添加编码器
        /// </summary>
        /// <param name="nozzleEncodercontrols"></param>
        /// <param name="fuelId"></param>
        /// <param name="stationId"></param>
        /// <param name="blackBoxid"></param>
        /// <returns></returns>
        public async Task AddEncoderControls(NozzleEncodercontrol[] nozzleEncodercontrols, int fuelId, int? stationId,int? blackBoxid)
        {
            List<EncoderControlsEntity> list = new List<EncoderControlsEntity>();
            foreach (var encoderControls in nozzleEncodercontrols)
            {
                DateTime? onlineStatusDate = DateTimeOffset.FromUnixTimeMilliseconds(encoderControls.onlineStatusDate).UtcDateTime;
                DateTime? modifiedDate = DateTimeOffset.FromUnixTimeMilliseconds(encoderControls.modifiedDate).UtcDateTime;
                DateTime? productTime = DateTimeOffset.FromUnixTimeMilliseconds(encoderControls.productTime).UtcDateTime;
                DateTime? fixTime = DateTimeOffset.FromUnixTimeMilliseconds(encoderControls.fixTime).UtcDateTime;
                DateTime? soldTime = DateTimeOffset.FromUnixTimeMilliseconds(encoderControls.soldTime).UtcDateTime;
                DateTime? createdDate = DateTimeOffset.FromUnixTimeMilliseconds(encoderControls.createdDate).UtcDateTime;
                DateTime? startTime = DateTimeOffset.FromUnixTimeMilliseconds(encoderControls.startTime).UtcDateTime;
                EncoderControlsEntity entity = new EncoderControlsEntity
                {
                    // 按类定义逐项赋值
                    DeviceAlarmLevel = encoderControls.deviceAlarmLevel,
                    OnlineStatus = encoderControls.onlineStatus,
                    SignVerify = encoderControls.signVerify,
                    Uuid = encoderControls.uuid,
                    DeviceStatus = encoderControls.deviceStatus,
                    SupplierID = null,
                    ModifiedBy = encoderControls.modifiedBy,
                    StartTime = startTime,
                    AlarmLevel = encoderControls.alarmLevel,
                    Id = encoderControls.id,
                    DispenserSupplierId = encoderControls.dispenserSupplierId,
                    Dirty = encoderControls.dirty,
                    FixTime = fixTime,
                    AlarmDetail = JsonSerializer.Serialize(encoderControls.alarmDetail),
                    CreatedDate = createdDate,
                    CreatedBy = encoderControls.createdBy,
                    ModifiedDate = modifiedDate,
                    CpuUuid = null,
                    SN = encoderControls.sn,
                    Hdv = encoderControls.hdv,
                    Signature = encoderControls.signature,
                    EncoderSoftware = null,
                    BlackBoxID = blackBoxid,
                    StationID = stationId,
                    MeterID = null,
                    ProductTime = productTime,
                    SoldTime = soldTime,
                    photoId = encoderControls.photoId,       
                    Alarms = JsonSerializer.Serialize(encoderControls.alarms),
                    lawSwv = encoderControls.lawSwv,       
                    lawSwi = encoderControls.lawSwi ,
                    FuelId = fuelId
                };
                list.Add(entity);
            }
            await _encoderControlsRepository.InsertAsync(list);
        }
        /// <summary>
        /// 添加安全装置
        /// </summary>
        /// <param name="blackbox"></param>
        /// <param name="fuelId"></param>
        /// <param name="stationId"></param>
        /// <returns></returns>
        public async Task AddBlackBox(NozzleBlackbox blackbox, int fuelId, int? stationId)
        {
            try
            {
                DateTime? onlineStatusDate = DateTimeOffset.FromUnixTimeMilliseconds(blackbox.onlineStatusDate).UtcDateTime;
                DateTime? alarmTime = DateTimeOffset.FromUnixTimeMilliseconds(blackbox.alarmTime).UtcDateTime;
                DateTime? productTime = DateTimeOffset.FromUnixTimeMilliseconds(blackbox.productTime).UtcDateTime;
                DateTime? fixTime = DateTimeOffset.FromUnixTimeMilliseconds(blackbox.fixTime).UtcDateTime;
                DateTime? soldTime = DateTimeOffset.FromUnixTimeMilliseconds(blackbox.soldTime).UtcDateTime;
                DateTime? createdDate = DateTimeOffset.FromUnixTimeMilliseconds(blackbox.createdDate).UtcDateTime;
                DateTime? registerUpdateTime = DateTimeOffset.FromUnixTimeMilliseconds(blackbox.registerUpdateTime).UtcDateTime;
                DateTime? startTime = DateTimeOffset.FromUnixTimeMilliseconds(blackbox.startTime).UtcDateTime;

                BlackBoxEntity entity = new BlackBoxEntity
                {
                    // 按你提供的完整类结构逐项赋值
                    Alarming = blackbox.alarming,
                    ResetTimes = blackbox.resetTimes,
                    OnlineStatusDate = onlineStatusDate,
                    DeviceAlarmLevel = blackbox.deviceAlarmLevel,
                    OnlineStatus = blackbox.onlineStatus,
                    ProductTime = productTime,
                    Uuid = blackbox.uuid,
                    SignVerify = blackbox.signVerify,
                    DeviceStatus = blackbox.deviceStatus,
                    FuelID = fuelId,
                    QrCode = blackbox.qrCode,
                    ModifiedBy = blackbox.modifiedBy,
                    AlarmLevel = blackbox.alarmLevel,
                    Id = blackbox.id,
                    Filtering = blackbox.filtering,
                    DispenserSupplierId = blackbox.dispenserSupplierId,
                    TaxType = blackbox.taxType,
                    NozzleControlName = blackbox.nozzleControlName,
                    FixTime = fixTime,
                    SoldTime = soldTime,
                    AlarmDetail = JsonSerializer.Serialize(blackbox.alarmDetail),
                    CreatedDate = createdDate,
                    CreatedBy = blackbox.createdBy,
                    ModifiedDate = blackbox.modifiedDate,
                    OfflineAlarmLevel = blackbox.offlineAlarmLevel,
                    Swv = blackbox.swv,
                    hdv = blackbox.hdv,
                    AlarmTime = alarmTime,
                    Imsi = blackbox.imsi,
                    Iccid = blackbox.iccid,
                    CpuUuid = blackbox.cpuUuid,
                    RegisterUpdateTime = registerUpdateTime,
                    SnapshotJson = JsonSerializer.Serialize(blackbox.snapshot2),
                    Xattrs = JsonSerializer.Serialize(blackbox.xattrs),
                    IotType = blackbox.iotType,
                    StationID = stationId,
                    supplierID = null,
                    FactorySupplierID = null,
                    StartTime = startTime,
                    PhotoId = blackbox.photoId,
                    Alarms = JsonSerializer.Serialize(blackbox.alarms),
                    LawSwv = null,
                    LawSwi = null,
                };


                await _blackBoxRepository.InsertAsync(entity);
            }
            catch (Exception ex)
            {

            }
        }

        static string GenerateSecureRandomString(int length)
        {
            const string chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
            StringBuilder sb = new StringBuilder();
            byte[] randomBytes = new byte[length];

            using (var rng = RandomNumberGenerator.Create())
            {
                rng.GetBytes(randomBytes); // 生成随机字节
            }

            for (int i = 0; i < length; i++)
            {
                int index = randomBytes[i] % chars.Length; // 将字节映射到字符范围
                sb.Append(chars[index]);
            }

            return sb.ToString();
        }
    }
}
